C     EMBED COMMON
C
C     Purpose: Common definition for embedding cube.
C
C     History: - Creation (12.10.00, AMK)
C
C     ******************************************************************
C
C     List of variables:
C
C     CEMBED : Embedding point coordinates.
C     ELFIELD: Electric field components.
CCC ADLL
C     EFCT   : 
C     EFPUL  :
C     EFWT   :
C     FSHAPE : Temporal shape of electric field envelop. 
CCC ADLL
C     NEMBED : Number of embedding points.
C     QEMBED : Charge of embedding points.
C     REMBED : Radius assigned to embedding points.
C
C     ------------------------------------------------------------------
C
C     *** Common block for INTEGER variables ***
C
      INTEGER NEMBED
C
      COMMON /IEMBEDDING/ NEMBED
C
C     *** Common block for REAL variables ***
C
CCC ADLL
      REAL EFCT,EFPUL,EFWT 
CCC ADLL
      REAL CEMBED(3,MAXCUBE,4),ELFIELD(3),QEMBED(MAXCUBE),
     $     REMBED(MAXCUBE)
C
      COMMON /REMBEDDING/ CEMBED,ELFIELD,QEMBED,REMBED
CCC ADLL
     $                    ,EFCT,EFPUL,EFWT
C
C     *** Common block for CHARACTER string ***
C
      CHARACTER*80 FSHAPE
C
      COMMON /CEMBEDDING/ FSHAPE
CCC ADLL
C
C     ------------------------------------------------------------------
