C     NUMINT COMMON
C
C     Purpose: Common block definition for numerical integrations. 
C
C     History: - Creation (15.10.16, ADLL)
C
C     ******************************************************************
C
C     List of integer variables:
C
C     MAXGS   : Maximum number of grid sets.
C     CAPGSN  : grid set number for complex absorbing potential.
C     TOPGSN  : grid set number for topological analysis.
C     XCGSN   : grid set number for XC numerical integration.
C  
C     ------------------------------------------------------------------
C
C     *** Numerical integration parameters ***
C
      INTEGER CAPGSN,TOPGSN,XCGSN,MAXGS
C
      PARAMETER (CAPGSN = 1,
     $           TOPGSN = 2,
     $           XCGSN = 3,
     $           MAXGS = 3)
C
C     *** Common block for INTEGER grid variables ***
C
      INTEGER LLGP_GST(MAXATOM,MAXGS),
     $        LRADIAL_GST(MAXATOM,MAXRAD,MAXGS), 
     $        NRADIAL_GST(MAXATOM,MAXGS),ULGP_GST(MAXATOM,MAXGS)
C
      COMMON /INUMINT/ LLGP_GST,LRADIAL_GST,NRADIAL_GST,ULGP_GST
C
C     *** Common block for LOGICAL grid variables ***
C
      LOGICAL RETGRD_GST(MAXGS)
C
      COMMON /LNUMINT/ RETGRD_GST
C
C     ------------------------------------------------------------------
C
