C     PROJECTILE COMMON
C
C     Purpose: Common definition for calculation projectiles 
C
C     History: - Creation (17.06.17, ADLL)
C
C     MRAD    : Mass of incident projectile.
C     QIORAD  : Electric charge of incident projectile.
C     DISRAD  : Initial distance of incident projectile from COM.
C     X0IORAD : Initial position of projectile.
C     KINRAD  : Kinetic energy of projectile.
C     DPLRAD  : Collision parameter.
C     VIORAD  : Unitary velocity vector of the projectile.
C     ADDRAD  : If true, add electric field generated by the projectile.
C     USELWP  : Use Lienard Wierchet potential.
C
C     ******************************************************************
C
C     List of variables:
C
C     ------------------------------------------------------------------
C
C     *** Common block for INTEGER PROJEC variables ***
C
      INTEGER NRADP,FRARAD
C
      COMMON /IPROJEC/ NRADP,FRARAD
C
C     *** Common block for REAL PROJEC variables ***
C
      REAL ERADIA(2),KINRAD,MRAD,QIORAD
C
      REAL CRAD(3,MAXRADP,5),QRAD(MAXRADP),VIORAD(3,MAXRADP),
     $     X0IORAD(3,MAXRADP),RRAD(MAXRADP),DPLRAD(3,MAXRADP),
     $     DISRAD(MAXRADP),ELSPEC(1000,2)
C
      COMMON /RPROJEC/ ERADIA,DISRAD,KINRAD,MRAD,QIORAD,CRAD,QRAD,
     $                 VIORAD,X0IORAD,RRAD,DPLRAD,ELSPEC 
C
C     *** Common Block for logical ***
C
      LOGICAL ADDRAD,USELWP
C
      COMMON /LPROJEC/ ADDRAD,USELWP
C 
C     ------------------------------------------------------------------
