C     RTDFT COMMON
C
C     Purpose: Common definition for RTDFT calculation.
C
C     History: - Creation (09.09.15, XJ)
C
C     ******************************************************************
C
C     List of variables:
C
C     DEPERT     : Deposited energy with respect to previous time.
C     RTAMAX     : Maximum time step for analysis.
C     RTAMIN     : Minimum time step for analysis.
C     RTMAX      : Maximum number of step for RTDFT.
C     EGIS       : Matrix of Eigenvalue 
C     RTSTEP     : Time of each step for RTDFT
C     RTLSTEP    : Displacement length to determine RTSTEP.
C     RTT        : time at the momen
C     RTINT      : Step interval for RTDFT printing.
C     RTCYC      : numer of cycle for RTDFT
C     GRTCYC     : GLOBAL number of cycle for RTDFT (necessary for PART in MD)
C     FGRTCYC    : First value of GRTCYC in current calculation.
C     PROPAGA    : PROPAGATION METHOD
C     MMAGNU     : METHOD FOR MAGNUS PROPAGATION  
C     MAXEMO{A/B}: Maximum energy in electronic spectra.
C     MINEMO{A/B}: Maximum energy in electronic spectra.
C     CHEBTOL    : Tolerance criteria in Taylor or Chebychev expansions.
C     RTDIAG     : Frequency for recomputing electronic spectrum.
C     DOIKS      : If true, do matrix multiplication involving Im(KS)
C     ------------------------------------------------------------------
C
C     *** Common block for iteration limits ***
C
      INTEGER KICKCYC,NEXPM,RTAMAX,RTAMIN,RTMAX,RTCYC,RTINT,RTPRO,
     $        RTDELEC,RTSAV,GRTCYC,FGRTCYC
     $        ,RTSMAX,RTDIAG
C
      COMMON /IRTDFT/ KICKCYC,NEXPM,RTAMAX,RTAMIN,RTMAX,RTCYC,
     $        RTINT,RTPRO,RTDELEC,RTSAV
     $        ,GRTCYC,FGRTCYC
     $        ,RTSMAX,RTDIAG

C     *** Common block for REAL RTDFT variables ***
C
      REAL DEPERT,DERAD,NEXPON,RTSTEP,RTLSTEP,RTT,P1ABS,P2ABS,P3ABS,
     $     P4ABS,RTETOL,RTCDTOL,MAXEMOA,MAXEMOB,MINEMOA,
     $     MINEMOB,CHEBTOL,CHEBSCA
C
      REAL VABS(MAXGPB)
C
      COMMON /RRTDFT/ DEPERT,DERAD,NEXPON,RTSTEP,RTLSTEP,RTT,P1ABS,
     $    P2ABS,P3ABS,P4ABS,VABS,
     $    RTETOL,RTCDTOL,MAXEMOA,MAXEMOB,MINEMOA,MINEMOB,CHEBTOL,CHEBSCA
C
C     *** Common block for CHARACTER string ***
C
      CHARACTER*80 PROPAGA
      CHARACTER*80 EXPMAT 
      CHARACTER*10 CAPTYP 
C
      COMMON /CRTDFT/ CAPTYP,PROPAGA,EXPMAT
C
C     *** Common block for vectors ***
C
      REAL EGIS(MAXSTO)
C
      COMMON /VRTDFT/ EGIS
C
C     *** Common Block for logical ***
C
      LOGICAL ABSPOT,ADRTSTEP,IMTPR,MAGPC,MAGIT,MLRT,DOIKS,REFABS
C
      COMMON /LTDFT/ ABSPOT,ADRTSTEP,IMTPR,MAGPC,MAGIT,MLRT,DOIKS,REFABS
C 
C     ------------------------------------------------------------------
