C     TOLERANCE COMMON
C
C     Purpose: Common definition for numerical tolerances.
C
C     History: - Creation (16.01.96, AMK)
C                         (08.09.08, GG)
C
C     ******************************************************************
C
C     List of variables:
C
C     ADPTOL : Tolerance for Eirola-Nevanlinna ADPT convergence.
C     CANTOL : Tolerance for canonical orthogonalization.
C     CDCTOL : Tolerance for charge density fitting coefficients.
C     CDFTOL : Tolerance for charge density fitting convergence.
C     CDPTOL : Tolerance for charge density perturbation convergence.
C     CFPTOL : Tolerance for CFP integration.
C     DIISTOL: Tolerance for DIIS initialization.
C     ERITOL : Tolerance for ERI thresholds.
C     FFPTOL : Finite field perturbation SCF tolerance.
C     FIXTOL : Tolerance for fixing of MOs.
C     GEOTOL : Tolerance for Cartesian coordinates.
C     GPCTOL : Tolerance for Lebedev grid point coordinates.
C     GPWTOL : Tolerance for grid point weightes.
C     GRDTOL : Tolerance for automatic grid generation.
C     IRCTOL : Tolerance for IRC path convergence.
C     ISOTOL : Tolerance for isosurface reduction.
C     KRYTOL : Tolerance for Krylov space convergence.
C     LPTOL  : Tolerance for LP conservation in molecular dynamics.
C     MINTOL : Tolerance for MINRES convergence.
C     OPTTOL : Tolerance for geometry optimization convergence.
C     PCGTOL : Tolerance for PCG convergence.
C     SADFAC : Saddle optimization scaling factor.
C     SADTOL : Tolerance for saddle convergence.
C     SCFTOL : Tolerance for SCF convergence.
C     SCPTOL : Tolerance for SCP convergence.
C     SVDTOL : Tolerance for singular value decomposition.
C     TOPTOL : Tolerance for iterative Hirshfeld analysis.
C     XASTOL : Tolerance for XAS orthogonalization.
C     TINIEST: Tiniest tolerance.
C
C     ------------------------------------------------------------------
C
C     *** Common block for numerical tolerances ***
C
      REAL ADPTOL,CANTOL,CDCTOL,CDFTOL,CDPTOL,CFPTOL,DIISTOL,ERITOL,
     $     FFPTOL,FIXTOL,GEOTOL,GPCTOL,GPWTOL,GRDTOL,IRCTOL,ISOTOL,
     $     KRYTOL,LPTOL,MINTOL,OPTTOL,PCGTOL,SADFAC,SADTOL,SCFTOL,
     $     SCPTOL,SVDTOL,TOPTOL,XASTOL,TINIEST
CCC ADLL
     $     ,GRDTTOL
CCC ADLL
C
      COMMON /RTOLER/ ADPTOL,CANTOL,CDCTOL,CDFTOL,CDPTOL,CFPTOL,
     $                DIISTOL,ERITOL,FFPTOL,FIXTOL,GEOTOL,GPCTOL,
     $                GPWTOL,GRDTOL,IRCTOL,ISOTOL,KRYTOL,LPTOL,
     $                MINTOL,OPTTOL,PCGTOL,SADFAC,SADTOL,SCFTOL,
     $                SCPTOL,SVDTOL,TOPTOL,XASTOL,TINIEST
CCC ADLL
     $     ,GRDTTOL
CCC ADLL
C
C     ------------------------------------------------------------------
