      SUBROUTINE GETOMOS(EIGVAL,HOMO,NPLOTFUN,PLOTMO,PLOTMOS)
C
C     Purpose: Select occupied MOs for plot function.
C
C     History: - Creation (25.02.97, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     HOMO    : Highest occupied molecular orbital.
C     NPLOTFUN: Number of plot functions.
C     PLOTMOS : List of plot molecular orbitals.
C     PLOTMO  : a) PLOTMO = DEFAULT, use all occupied orbitals.
C               b) PLOTMO = OUGAP, use OCC-UNOC GAP orbitals (5+5).
C               c) PLOTMO = HLGAP, use HOMO and LUMO GAP orbitals.
C               d) PLOTMO = HOMO, use HOMO orbital.
C               e) PLOTMO = NONE, use no orbital.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'molecule.h'
C
      INTEGER PLOTMOS(0:*)
      REAL EIGVAL(MAXSTO)
C
      LOGICAL VIRTUAL
      CHARACTER *(*) PLOTMO
      INTEGER HOMO,IMO,NOMO,NPLOTFUN
C
C     ------------------------------------------------------------------
C
C     *** Get occupied MOs for plot function ***
C
      IF (PLOTMO.EQ.'DEFAULT') THEN
        PLOTMOS(0) = HOMO
        DO IMO=1,HOMO
          PLOTMOS(IMO) = IMO
        END DO
      ELSE IF (PLOTMO.EQ.'NONE') THEN
        PLOTMOS(0) = 0
      ELSE IF (PLOTMO.EQ.'HOMO') THEN
        PLOTMOS(0) = 1
        PLOTMOS(1) = HOMO
      ELSE IF (PLOTMO.EQ.'HLGAP') THEN
        PLOTMOS(0) = 2
        PLOTMOS(1) = HOMO
        PLOTMOS(2) = HOMO + 1
CCC ADLL
      ELSE IF (PLOTMO.EQ.'POSE') THEN
        NOMO = 0
        DO IMO=1,NSTO
          IF (EIGVAL(IMO).GT.0.0) THEN
            NOMO = NOMO + 1
            PLOTMOS(NOMO) = IMO
          END IF
        END DO
        PLOTMOS(0) = NOMO
CCC ADLL
      ELSE IF (PLOTMO.EQ.'OUGAP') THEN
        PLOTMOS(0) = 0
        DO IMO=HOMO-4,HOMO+5
          IF ((IMO.GE.1).AND.(IMO.LE.NSTO)) THEN
            NPLOTFUN = NPLOTFUN + 1
            PLOTMOS(0) = PLOTMOS(0) + 1
            PLOTMOS(PLOTMOS(0)) = IMO
          END IF
        END DO
      END IF
C
C     *** Check for virtual orbitals ***
C
      VIRTUAL = .FALSE.
      DO IMO=1,PLOTMOS(0)
        IF (PLOTMOS(IMO).GT.HOMO) VIRTUAL = .TRUE.
      END DO
C
      IF (VIRTUAL) THEN
        CALL ERRMSG('GETOMOS','PLOT CONTAINS VIRTUAL ORBITALS',0)
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE GETOMOS ***
C
      END
