      SUBROUTINE GRDGEN(PA,PB,DSTO)
C
C     Purpose: GRiD GENeration.
C
C     History: - Creation (16.04.96, MK)
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'flags.h'
      INCLUDE 'tolerance.h'
C
      INTEGER DSTO
      REAL PA(DSTO,DSTO),PB(DSTO,DSTO)
C
      CHARACTER*80 STRCOMP,PRTSTR,TIMSTR*30
      LOGICAL STATED
      INTEGER STREXT
C
C     ------------------------------------------------------------------
C
C     *** Start timer for grid generation ***
C
      PRTSTR = STRCOMP(GRDTYP//' GRID GENERATION')
      TIMSTR = PRTSTR(:STREXT(PRTSTR))
C
      IF (.NOT.STATED('ATOM')) CALL TIMER('START',TIMSTR)
C
C     *** Select grid type to be generated ***
C
      IF (PRTGRD.AND.((STATUS.EQ.'SCF').OR.
     $   (STATUS.EQ.'ESA').OR.(STATUS.EQ.'TOPO'))) THEN
C
        IF (STATUS.EQ.'ESA') THEN
          PRTSTR = 'GENERATING POPULATION ANALYSIS GRID'
        ELSE IF (STATUS.EQ.'TOPO') THEN
          PRTSTR = 'GENERATING TOPOLOGICAL GRID'
        ELSE
          PRTSTR = 'GENERATING '//GRDTYP//' GRID'
        END IF
        CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
C
        IF (GRDTYP.EQ.'ADAPTIVE') THEN
          WRITE (PRTSTR,5000) GRDTOL
 5000     FORMAT ('REQUESTED GRID TOLERANCE:',G10.3)
          CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
        END IF
C
      END IF
C
C     *** Select grid type ***
C
CCC ADLL
      IF (STATUS.EQ.'BLDCAP') THEN
        CALL G98GRDABS(G98TYP)
      ELSE IF (GRDTYP.EQ.'ADAPTIVE') THEN
CCC ADLL
        CALL AUTOGRD(PA,PB,DSTO)
      ELSE IF (GRDTYP.EQ.'FIXED') THEN
        CALL G98GRD(G98TYP)
      ELSE
        CALL ERRMSG('GRDGEN','UNKNOWN GRID TYPE',1)
      END IF
C
C     *** Stop timer for grid generation ***
C
      IF (.NOT.STATED('ATOM')) CALL TIMER('STOP',TIMSTR)
C
      IF (STATUS.EQ.'SCF') CALL TIMER('PRINT STEP',TRIM(TIMSTR))
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE GRDGEN ***
C
      END
