      SUBROUTINE NEWKEY(OPTION)
C
C     Purpose: Write user defined keywords in new input file. 
C
C     History: - Creation (09.06.03, UR)
C
C     ******************************************************************
C
C     List of local variables:
C
C     KEYWORDS: Keyword list.
C     SUCCESS : If true, keyword was found in the input.
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'fileio.h'
      INCLUDE 'keywords.h'
      INCLUDE 'strings.h'
C
      CHARACTER*(*) OPTION
C
      LOGICAL BLOCKEND,SUCCESS
      CHARACTER*500 STRCOMP,STRING
      CHARACTER*80 DTS,LINE,LTU,NEXTLINE*81
C
      INTEGER IKEY,LINLEN,STREXT,TITLEN
C
C     ------------------------------------------------------------------
C
C     *** Write Title ***
C
      TITLEN = STREXT(TITLE) + 1
C
      IF (TITLEN.GT.0) THEN
        WRITE (NEW,'(A,1X,A)') 'TITLE',TITLE(:TITLEN)
      END IF
C
      WRITE (NEW,'(A)') COMMENT
C
C     *** Write user defined input keywords ***
C
      DO IKEY=2,MAXKEY
C
        IF (KEYWORDS(IKEY)%WRITE_KEYWORD_IN_NEW_INPUT) THEN
C
C     *** Find keyword options and body ***
C
          CALL FINDKEY(KEYWORDS(IKEY)%FULL_KEYWORD,SUCCESS)
C
          IF (SUCCESS) THEN
C
C     *** Read original keyword input line(s) ***
C
            BACKSPACE (INP)
            READ (INP,'(A80)',ERR=99980,END=99990) LINE
            STRING = STRCOMP(LTU(DTS(LINE)))
            DO WHILE (LINE(STREXT(LINE):STREXT(LINE)).EQ.NEWLINE)
              READ (INP,'(A80)',ERR=99980,END=99990) LINE
              NEXTLINE = ' '//STRCOMP(LTU(DTS(LINE)))
              STRING = STRCOMP(STRING(:STREXT(STRING)-1)//NEXTLINE)
            END DO
C
C     *** Keyword lines that might be modified ***
C
            IF (OPTION.NE.'STEP INPUT') THEN
              CALL IRCKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'MODIFY')
              CALL SCFKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'MODIFY')
              CALL SVDKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'MODIFY')
              CALL TRJKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'MODIFY')
              CALL FREQKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'MODIFY')
CCC ADLL 
              CALL RTPKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'MODIFY')
CCC ADLL
            END IF
C
C     *** Write new keyword input line(s) ***
C
            CALL WRITEKEY(STRING)
C
C     *** Write new keyword body ***
C
            READ (INP,'(A80)',ERR=99980,END=1000) LINE
            STRING = STRCOMP(LTU(DTS(LINE)))
            DO WHILE (.NOT.BLOCKEND(STRING))
              LINLEN = STREXT(LINE)
              WRITE (NEW,'(A)') LINE(1:LINLEN)
              READ (INP,'(A80)',ERR=99980,END=1000) LINE
              STRING = STRCOMP(LTU(DTS(LINE)))
            END DO
C
C      *** Add keyword to input ***
C
          ELSE
C
            CALL RSTKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING)
            CALL SCFKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'NEW')
            CALL SVDKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'NEW')
            CALL TRJKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'NEW')
            CALL FREQKEY(KEYWORDS(IKEY)%FULL_KEYWORD,STRING,'NEW')
C
C       *** Write new added keyword input line(s) ***
C
            CALL WRITEKEY(STRING)
C
          END IF
C     
        END IF
C
 1000 CONTINUE
C
      END DO
C
      RETURN
C
C     ------------------------------------------------------------------
C
C     *** Handling of read errors ***
C
99980 CONTINUE
      CALL MESSAGE(0,'--> '//TRIM(LINE),1,0)
      CALL ERRMSG('NEWKEY','ERROR READING INPUT LINE',1)
C
99990 CONTINUE
      CALL ERRMSG('NEWKEY','EOF OF INPUT FILE',1)
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE NEWKEY ***
C
      END
