      SUBROUTINE TRFMOAMAGMA(hMATRIX,DSTO,DSTO_ME,OPTION)
C
C     Purpose: Perform AO <-> MO transformations with MAGMA.
C
C     History: - Creation (10.08.21, KH)
C
C     ******************************************************************
C
C     List of local dimensions:
C
C     DSTO: Dimension of MATRIX.
C
C     List of local variables:
C    
C     MATRIX : Matrix to be transformed -> The transfored matrix MO(OA)  
C     OPTION : a) PAO->PMO, transform density matrix from AO to MO basis
C              b) PMO->PAO, transform density matrix from MO to AO basis
C              c) KAO->KMO, transform Fock matrix from AO to MO basis
C     S      : Overlap matrix -> Canonical orthogonalization matrix.
C     Y      : Y = S*eigenvalue
C     C      : Work matrix. 
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C     
      CHARACTER*(*) OPTION
      INTEGER(kind=4) DSTO,DSTO_ME
      REAL hMATRIX(DSTO_ME,DSTO_ME)

C     ------------------------------------------------------------------
C
C     *********************
C     *** DUMMY ROUTINE ***
C     *********************
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE TRFMOAMAGMA ***
C
      END

