      SUBROUTINE OVERDIA(P,OVDD,STO,DSTO,LLGPB,NGPB)
C
C     Purpose: Numerical calculation of the density at the grid point
C              of the current batch of grid points.
C
C     ******************************************************************
C
C     List of local variables:
C
C     NGPB: Number of grid points in the current batch.
C     P   : Alpha/Beta density matrix.
C     PSTO: Work vector (P(mu,nu)*Chi(nu)).
C     RHOS: Density values of the current batch of grid points.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'grid.h'
      INCLUDE 'molecule.h'
      INCLUDE 'pointer.h'
      INCLUDE 'threshold.h'
C
C     ------------------------------------------------------------------
C
      INTEGER DSTO
      REAL P(DSTO,DSTO)
      REAL STO(MAXGPB,DSTO)
      REAL OVDD(DSTO) 
C
      INTEGER IGP,LLGPB,NGPA,NGPB
      INTEGER IATOM,INEIGH,ISHL,ISTO,JATOM,JNEIGH,JSTO
      REAL XAG,YAG,ZAG
      INTEGER IGPPTR(MAXGPB)
      REAL DAG(MAXGPB),PSTO(MAXGPB),WGRID(MAXGPB)
C
C     ------------------------------------------------------------------
C
      DO IGP=1,NGPB
        WGRID(IGP) = GRDVEC(4,LLGPB+IGP-1)
      END DO

C     *** Loop over all neighbors ***
C
      DO INEIGH=1,NNEIGH
C
        IATOM = NEIGH(INEIGH)
C
        DO IGP=1,NGPB
          XAG = GRDVEC(1,LLGPB+IGP-1) - COORD(1,IATOM,CCSET)
          YAG = GRDVEC(2,LLGPB+IGP-1) - COORD(2,IATOM,CCSET)
          ZAG = GRDVEC(3,LLGPB+IGP-1) - COORD(3,IATOM,CCSET)
          DAG(IGP) = XAG**2 + YAG**2 + ZAG**2
        END DO
C
        DO ISHL=LLSHL(IATOM),ULSHL(IATOM)
C
C     *** Select active grid points of current shell ***
C
          NGPA = 0
          DO IGP=1,NGPB
            IF (DAG(IGP).LE.SHLRAD(ISHL)) THEN
              NGPA = NGPA + 1
              IGPPTR(NGPA) = IGP
            END IF
          END DO
C
          IF (NGPA.EQ.0) CYCLE
C
          DO ISTO=LLSTO(ISHL),ULSTO(ISHL)
            PSTO(1:NGPA) = 0.0
            DO JNEIGH=1,NNEIGH
              JATOM = NEIGH(JNEIGH)
              DO JSTO=LL(JATOM),UL(JATOM)
                IF (ISTO.LE.JSTO) THEN
                  IF (ABS(P(ISTO,JSTO)).GT.PTHRESH) THEN
                    IF (NGPA.EQ.NGPB) THEN
                      PSTO(1:NGPB) = PSTO(1:NGPB) + P(ISTO,JSTO)*
     $                               STO(1:NGPB,JSTO)
                    ELSE
                      PSTO(1:NGPA) = PSTO(1:NGPA) + P(ISTO,JSTO)*
     $                               STO(IGPPTR(1:NGPA),JSTO)
                    END IF
                  END IF
                ELSE
                  IF (ABS(P(JSTO,ISTO)).GT.PTHRESH) THEN
                    IF (NGPA.EQ.NGPB) THEN
                      PSTO(1:NGPB) = PSTO(1:NGPB) + P(JSTO,ISTO)*
     $                               STO(1:NGPB,JSTO)
                    ELSE
                      PSTO(1:NGPA) = PSTO(1:NGPA) + P(JSTO,ISTO)*
     $                               STO(IGPPTR(1:NGPA),JSTO)
                    END IF
                  END IF
                END IF
              END DO
            END DO

            DO IGP=1,NGPA
              OVDD(ISTO) = OVDD(ISTO) + 
     $         WGRID(IGPPTR(IGP))*PSTO(IGP)
     $         *STO(IGPPTR(IGP),ISTO)
            END DO
          END DO
C
        END DO
      END DO

C
C     *** End of SUBROUTINE RHO ***
C
      END
