      SUBROUTINE CONNECMM
C
C     Purpose: Calculate MM atoms connectivity matrix and local
C              neighbours
CTODO
CTODO Only for compatibility
CTODO
C
C     History: - Creation (14.03.09, AG)
C                         (14.06.17, GG)
C
C     ******************************************************************
C
C     List of local variables:
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
C
      INTEGER I,IATOM,I1,I2,I3,I4,J,JATOM,K
C
      INTEGER TMP(4)
C
      INTEGER ALLOCATION
      INTEGER,ALLOCATABLE :: CONVEC(:)
C
      LOGICAL SKIPTORS
CCC ADLL LA
      LOGICAL LAPAIR
CCC ADLL LA
C
C     ------------------------------------------------------------------
C
C     *** Allocate local fields ***
C
      ALLOCATE(CONVEC(NATMM),STAT=ALLOCATION)
      CALL CHKERRSTAT(ALLOCATION,'CONNECMM','ALLOCATION FAILED')
C
CTODO
CTODO *** This is only for reading process of interest! ***
CTODO
C
C     *** Find the Links between types of atoms ***
C
      NTYPLNK = 1
      TYPLNK(1,1) = TYPEMM(CBOND(1,1))
      TYPLNK(1,2) = TYPEMM(CBOND(1,2))
      DO I=2,NBOND
        I1 = TYPEMM(CBOND(I,1))
        I2 = TYPEMM(CBOND(I,2))
        K = 1
        DO J=1,I-1
          IF (((I1.EQ.TYPEMM(CBOND(J,1))).AND.
     $         (I2.EQ.TYPEMM(CBOND(J,2)))).OR.
     $        ((I2.EQ.TYPEMM(CBOND(J,1))).AND.
     $         (I1.EQ.TYPEMM(CBOND(J,2))))) THEN
            K = 0
          END IF
        END DO
        IF (K.NE.0) THEN
          NTYPLNK = NTYPLNK + 1
          TYPLNK(NTYPLNK,1) = I1
          TYPLNK(NTYPLNK,2) = I2
        END IF
      END DO
CTODO
CTODO *** End of reading process relevant part ***
CTODO
      NBANGS = 0
      DO IATOM=1,NATMM
C
C     *** Build connectivity ***
C
        CALL BLDBBT(CONVEC,IATOM)
C
        DO JATOM=1,NATMM
          IF (JATOM.NE.IATOM.AND.CONVEC(JATOM).EQ.0) THEN
            DO I=1,LINKMM(NATOM+IATOM,0)
CCC ADLL LA
              IF (LAPAIR(I,IATOM)) CYCLE
CCC ADLL LA
              DO J=1,LINKMM(NATOM+JATOM,0)
CCC ADLL LA
              IF (LAPAIR(J,JATOM)) CYCLE
CCC ADLL LA
                IF (LINKMM(NATOM+IATOM,I).EQ.LINKMM(NATOM+JATOM,J)) THEN
C                  IF (JATOM.GT.IATOM) THEN
CCC ADLL LA
                  IF ((LINKMM(NATOM+IATOM,I).NE.0).AND.
     $              (JATOM.GT.IATOM)) THEN
CCC ADLL LA
                    NBANGS = NBANGS + 1
                    BANGS(NBANGS,2) = LINKMM(NATOM+IATOM,I)
                    BANGS(NBANGS,1) = IATOM + NATOM
                    BANGS(NBANGS,3) = JATOM + NATOM
                  END IF
                END IF
              END DO
            END DO
          END IF
        END DO
      END DO
C
C     *** Sort double 1-3 interactions at the end ***
C
      MBANGS = NBANGS
      I = 1
      DO WHILE (I.LE.(MBANGS - 1))
        I1 = MIN(BANGS(I,1),BANGS(I,3))
        I2 = MAX(BANGS(I,1),BANGS(I,3))
        J = I + 1
        DO WHILE (J.LE.MBANGS)
          I3 = MIN(BANGS(J,1),BANGS(J,3))
          I4 = MAX(BANGS(J,1),BANGS(J,3))
          IF ((I1.EQ.I3).AND.(I2.EQ.I4)) THEN
            TMP(1:3) = BANGS(MBANGS,1:3)
            BANGS(MBANGS,1:3) = BANGS(J,1:3)
            BANGS(J,1:3) = TMP(1:3)
            MBANGS = MBANGS - 1
            CYCLE
          END IF
          J = J + 1
        END DO
        I = I + 1
      END DO
C
C     *** Sort 1-3 / 1-2 doubles at the end ***
C
      DO I=1,NBOND
        I1 = MIN(CBOND(I,1),CBOND(I,2))
        I2 = MAX(CBOND(I,1),CBOND(I,2))
        J = 1
        DO WHILE (J.LE.MBANGS)
          I3 = MIN(BANGS(J,1),BANGS(J,3))
          I4 = MAX(BANGS(J,1),BANGS(J,3))
          IF ((I1.EQ.I3).AND.(I2.EQ.I4)) THEN
            TMP(1:3) = BANGS(MBANGS,1:3)
            BANGS(MBANGS,1:3) = BANGS(J,1:3)
            BANGS(J,1:3) = TMP(1:3)
            MBANGS = MBANGS - 1
            CYCLE
          END IF
          J = J + 1
        END DO
      END DO
C
C     *** Define improper torsions ***
C
      NIMPTS = 0
      DO IATOM=1,NATMM
        IF (LINKMM(NATOM+IATOM,0).EQ.3) THEN
          I1 = LINKMM(NATOM+IATOM,1)
          I2 = LINKMM(NATOM+IATOM,2)
          I3 = IATOM + NATOM
          I4 = LINKMM(NATOM+IATOM,3)
CCC ADLL 
          IF ((I1.EQ.0).OR.(I2.EQ.0).OR.(I4.EQ.0)) CYCLE
CCC ADLL
          DO K=1,6
            NIMPTS = NIMPTS + 1
            IMPT(NIMPTS,3) = I3
            IF (K.EQ.1) THEN
              IMPT(NIMPTS,1) = I1               
              IMPT(NIMPTS,2) = I2                
              IMPT(NIMPTS,4) = I4                 
            ELSE IF (K.EQ.2) THEN
              IMPT(NIMPTS,1) = I4
              IMPT(NIMPTS,2) = I1
              IMPT(NIMPTS,4) = I2
            ELSE IF (K.EQ.3) THEN
              IMPT(NIMPTS,1) = I2          
              IMPT(NIMPTS,2) = I4
              IMPT(NIMPTS,4) = I1
            ELSE IF (K.EQ.4) THEN
              IMPT(NIMPTS,1) = I1
              IMPT(NIMPTS,2) = I4
              IMPT(NIMPTS,4) = I2
            ELSE IF (K.EQ.5) THEN
              IMPT(NIMPTS,1) = I4
              IMPT(NIMPTS,2) = I2
              IMPT(NIMPTS,4) = I1
            ELSE IF (K.EQ.6) THEN
              IMPT(NIMPTS,1) = I2
              IMPT(NIMPTS,2) = I1
              IMPT(NIMPTS,4) = I4
            END IF
          END DO
        END IF
      END DO
C
C     *** Define torsions ***
C
      NTANGS = 0
      DO I=1,NBOND
        I2 = CBOND(I,1)
        I3 = CBOND(I,2)
        DO J=1,LINKMM(I2,0)
          I1 = LINKMM(I2,J)
CCC ADLL LA
          IF (LAPAIR(I1,I2)) CYCLE
CCC ADLL LA
CCC ADLL 
          IF (I1.EQ.0) CYCLE
CCC ADLL 
          IF (I1.NE.I3) THEN
            DO K=1,LINKMM(I3,0)
              I4 = LINKMM(I3,K)
CCC ADLL LA
              IF (LAPAIR(I4,I3)) CYCLE
CCC ADLL LA
CCC ADLL 
          IF (I4.EQ.0) CYCLE
CCC ADLL 
              IF ((I4.NE.I2).AND.(I4.NE.I1)) THEN
                IF (.NOT.SKIPTORS(I1,I2,I3,I4)) THEN
                  NTANGS = NTANGS + 1
                  TANGS(NTANGS,1) = I1
                  TANGS(NTANGS,2) = I2
                  TANGS(NTANGS,3) = I3
                  TANGS(NTANGS,4) = I4
                END IF
              END IF
            END DO
          END IF
        END DO
      END DO
C
C     *** Sort double 1-4 interactions at the end ***
C
      MTANGS = NTANGS
      I = 1
      DO WHILE (I.LE.(MTANGS - 1))
        I1 = MIN(TANGS(I,1),TANGS(I,4))
        I2 = MAX(TANGS(I,1),TANGS(I,4))
        J = I + 1
        DO WHILE (J.LE.MTANGS)
          I3 = MIN(TANGS(J,1),TANGS(J,4))
          I4 = MAX(TANGS(J,1),TANGS(J,4))
          IF ((I1.EQ.I3).AND.(I2.EQ.I4)) THEN
            TMP(1:4) = TANGS(MTANGS,1:4)
            TANGS(MTANGS,1:4) = TANGS(J,1:4)
            TANGS(J,1:4) = TMP(1:4)
            MTANGS = MTANGS - 1
            CYCLE
          END IF
          J = J + 1
        END DO
        I = I + 1
      END DO
C
C     *** Sort 1-4 / 1-2 doubles at the end ***
C
      DO I=1,NBOND
        I1 = MIN(CBOND(I,1),CBOND(I,2))
        I2 = MAX(CBOND(I,1),CBOND(I,2))
        J = 1
        DO WHILE (J.LE.MTANGS)
          I3 = MIN(TANGS(J,1),TANGS(J,4))
          I4 = MAX(TANGS(J,1),TANGS(J,4))
          IF ((I1.EQ.I3).AND.(I2.EQ.I4)) THEN
            TMP(1:4) = TANGS(MTANGS,1:4)
            TANGS(MTANGS,1:4) = TANGS(J,1:4)
            TANGS(J,1:4) = TMP(1:4)
            MTANGS = MTANGS - 1
            CYCLE
          END IF
          J = J + 1
        END DO
      END DO
C
C     *** Sort 1-4 / 1-3 doubles at the end ***
C
      DO I=1,MBANGS
        I1 = MIN(BANGS(I,1),BANGS(I,3))
        I2 = MAX(BANGS(I,1),BANGS(I,3))
        J = 1
        DO WHILE (J.LE.MTANGS)
          I3 = MIN(TANGS(J,1),TANGS(J,4))
          I4 = MAX(TANGS(J,1),TANGS(J,4))
          IF ((I1.EQ.I3).AND.(I2.EQ.I4)) THEN
            TMP(1:4) = TANGS(MTANGS,1:4)
            TANGS(MTANGS,1:4) = TANGS(J,1:4)
            TANGS(J,1:4) = TMP(1:4)
            MTANGS = MTANGS - 1
            CYCLE
          END IF
          J = J + 1
        END DO
      END DO
C
C     *** Deallocate local matrix ***
C
      DEALLOCATE(CONVEC,STAT=ALLOCATION)
      CALL CHKERRSTAT(ALLOCATION,'CONNECMM','DEALLOCATION FAILED')
C
      RETURN
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE CONNECMM *** 
C
      END

