      SUBROUTINE D1EMBEDMM(GRADIENT,P,DSTO,DXYZ)
C
C     Purpose: Calculation of embedded core energy derivatives.
C
C     History: - Creation (23.01.13, AAI)
C                         (04.02.13, AMK)
C
C     ******************************************************************
C
C     List of local dimensions:
C
C     DSTO: Dimension of Slater typ orbital matrix.
C     DXYZ: Dimension of x, y or z degrees of freedom.
C
C     List of local variables:
C
C     GRADIENT: SCF energy gradient vector.
C    
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER DXYZ,DSTO
      REAL GRADIENT(3,DXYZ),P(DSTO,DSTO)
C
C     ------------------------------------------------------------------
C
CCC ADLL LA
C     *** Scale down MM charges near link atoms ***
C
      CALL SCLCHGMM('SCALE')
C
CCC ADLL LA
C
C     *** Calculate near-field embedding gradients ***
C
      CALL D1NEARQMMM(GRADIENT,P,DSTO,DXYZ)
C
C     *** Calculate far-field embedding gradients ***
C
      CALL D1FARQMMM(GRADIENT,P,DSTO,DXYZ)
C
CCC ADLL LA
C     *** Restore orginal charges ***
C
      CALL SCLCHGMM('RESTORE')
C
CCC ADLL LA
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE D1EMBEDMM ***
C
      END
