      SUBROUTINE MMDRV
C
C     Purpose: Driver for the calculation of the molecular mechanics
C              energy.
C
C     History: - Creation  (01.07.14, AG)
C                          (13.11.14, GG)
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'mm.h'
      INCLUDE 'mmpot.h'
      INCLUDE 'mp_demon.h'
CCC ADLL LA
      INCLUDE 'qmmm.h'
CCC ADLL
      INCLUDE 'opt.h'
C
      CHARACTER TIMSTR*80
C
C     ------------------------------------------------------------------
C
C     *** Count energy evaluations ***
C
      IF (MMONLY) ENERCYC = ENERCYC + 1
C
C     *** Start timer for MM energy calculation ***
C
      IF (MPP) THEN
        TIMSTR = 'MPI MM ENERGY'
      ELSE
        TIMSTR = 'MM ENERGY'
      END IF
C
      CALL TIMER('START',TIMSTR)
C
C     *** Initialization ***
C
      EMM = 0.0
      EBOND = 0.0
      EBANG = 0.0
      ETORS = 0.0
      EIMPTORS = 0.0
      EUREY = 0.0
      EQQMM = 0.0
      EVDWMM = 0.0
C
C     *** Calculate force field bond energy ***
C
      CALL BONDMM
CTODO
CTODO New structure until here!
CTODO
C
C     *** Bond Angle Energy ***
C
      IF (DOBANG) CALL BANGNRGY
C
C     *** Torsion Energy ***
C
      IF (DOTORS) CALL TORSNRGY
C
C     *** Improper Torsion Energy ***
C
      IF (DOIMPTORS) CALL IMPTORSNRGY
C
C     *** Urey Bradley Energy ***
C
      IF (DOUREY) CALL UREYNRGY
C
C     *** Non Bonding Energy ***
C
      IF (DOVDW) CALL LJNRGY
C
C     *** Electrostatic Energy ***
C
      IF (DOCHARGE) CALL CHGNRGY
CTODO
CTODO New structure from here on again!
CTODO
C
CCC ADLL LA
C    *** Calculate link atom bond energy ***
      IF (LINKAT) CALL EQMMMFRT
CCC ADLL LA
C
C     *** Calculate MM energy ***
C
      EMM = EBOND + EBANG + ETORS + EIMPTORS + EUREY + EVDWMM + EQQMM
C
C     *** Print moelcular mechanics energies ***
C
      CALL MMOUT
C
C     *** Stop timer for MM energy calculation ***
C
      CALL TIMER('STOP',TIMSTR)
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE MMDRV ***
C
      END
