      SUBROUTINE NUCQMMM
C
C     Purpose: NUCQMMM calculates the Interaction energy between
C              the QM nuclei and the MM multipoles
C
C     History: - Creation (17.03.09, AG)
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'mm.h'
      INCLUDE 'mmnrgy.h'
      INCLUDE 'molecule.h'
C
      INTEGER IATOM,KATOM
      REAL D
C
      REAL R(3)
C
C     ------------------------------------------------------------------
C
      NUCZMM = 0.0

      IF (.NOT.QMMM) RETURN
CCC ADLL LA
C     *** Scale down MM charges near link atoms ***
C
      CALL SCLCHGMM('SCALE')
C
CCC ADLL LA
C
      DO IATOM=1,NATOM
        DO KATOM=1,NATMM
          CALL QMMMDIS(IATOM,KATOM,R,D)
          NUCZMM = NUCZMM + ZATOM(IATOM)*CHGMM(KATOM)/SQRT(D)
        END DO
      END DO
C
CCC ADLL LA
C     *** Restore orginal charges ***
C
      CALL SCLCHGMM('RESTORE')
C
CCC ADLL LA

C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE NUCQMMM ***               
C
      END
