      SUBROUTINE BLDCONNECLA(IATOM,ILA)
C
C     Purpose: Build connectivity for QM atoms of QM/MM frontier, on the
C     QM side only, and excluding the link atom itself.
C
C     History: - Creation (27.07.18, ADLL)
C
C     ******************************************************************
C
C     List of local variables:
C
C     IATOM : Atom for which connctivity is build.
C     ILA   : Link atom number for which the  
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
      INCLUDE 'qmmm.h'
C
      LOGICAL LINKED
      INTEGER IATOM,ILA,ILINK,JATOM,NLINK
C
C     ------------------------------------------------------------------
C
C     *** Build input based atomic link vector ***
C
      NLINK = 0
      DO JATOM=1,NATOM_ALL
        IF (TYPEMM(JATOM).GT.0) CYCLE
        IF (JATOM.EQ.LATQM(ILA,3)) CYCLE
C
        IF (LINKED(IATOM,JATOM)) THEN
          NLINK = NLINK + 1
          LINKLA(ILA,NLINK) = JATOM
        END IF 
      END DO
      LINKLA(ILA,0) = NLINK
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE BLDCONNECLA *** 
C
      END
