      SUBROUTINE SETLAPOS(OPTION)
C
C     Purpose : Set the coordinates of link atoms. 
C
C     History: - Creation (23.07.17, ADL)
C
C     *****************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
CCC ADLL 
C      INCLUDE 'fragment.h'
CCC ADLL
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
      INCLUDE 'physic.h'
      INCLUDE 'qmmm.h'
C
      CHARACTER*(*) OPTION
C
      INTEGER NATOMS,IATOM,ILA,JATOM,LATOM
      REAL RATIO,U(3)
      CHARACTER*3 NUMBER
      CHARACTER*5 LABEL
C
C     -----------------------------------------------------------------
C
C     *** Quick return in not QM/MM job or no LA involved ***
C
C      IF ((.NOT.QMMM).OR.(.NOT.LINKAT)) RETURN
C
      NATOMS = NATOM_ALL + NDUMMY
C
C     *** Assign default mass, atom number and label to link atoms ***
C
      IF (OPTION.EQ.'SET') THEN
        DO ILA=1,NLATOM
          IF (LATSYM.EQ.'H') THEN
            ATOMNO(NATOMS+ILA) = 1
          ELSE IF (LATSYM.EQ.'F') THEN
            ATOMNO(NATOMS+ILA) = 8
          ELSE 
            GO TO 99950
          END IF
          MATOM(NATOMS+ILA) = STDMATOM(ATOMNO(NATOMS+ILA))
          ZATOM(NATOMS+ILA) = ATOMNO(NATOMS+ILA)
          ZCORE(NATOMS+ILA) = 0
CCC ADLL FRG !! Assign same fragment type as QM frontier atom.
C          ATOMFRAG(NATOMS+ILA) = ATOMFRAG(LATQM(ILA,1))
CCC ADLL FRG  
          WRITE(NUMBER,'(I3)') ILA
          LABEL = LATSYM//'L'//ADJUSTL(NUMBER)
          ATOMLAB(NATOMS+ILA) = TRIM(LABEL)
          TYPEMM(NATOMS+ILA) = -1
        END DO
      END IF
C      
      DO ILA=1,NLATOM
        
        IATOM = LATQM(ILA,1)
        JATOM = LATQM(ILA,2) 
        LATOM = LATQM(ILA,3)
        RATIO = LATR(ILA)
        IF (RATIO.EQ.0.0) RATIO = 0.72
C
        U(:) = COORD(1:3,JATOM,CCSET) - COORD(1:3,IATOM,CCSET)
        COORD(1:3,LATOM,CCSET) = COORD(1:3,IATOM,CCSET) + RATIO*U(:)
      END DO
C

C      IF (OPTION.NE.'INPUT') THEN
C      WRITE(7,*) "NEW GEO WITH POSITIONNED LA"
C      DO ILA=1,NATOMS
C        WRITE(7,'(A,3(F12.8,1X))') ATOMLAB(ILA), 
C     $    (COORD(IATOM,ILA,CCSET)*0.5205,IATOM=1,3)
C      END DO
      RETURN
C     END IF
C     ------------------------------------------------------------------
C
C     *** Handling of read errors ***
C
99950 CONTINUE
      CALL ERRMSG('SETATPOS','LINK ATOMS MUST BE H OR F',1)
C
C
C     -----------------------------------------------------------------
C
C     *** End of SUBROUTINE SETLAPOS ***
C     
      END 
