      SUBROUTINE RADDIS(ATOM,POINT,RVECTOR,RSQUARE)
C
C     Purpose: Calculation of atomic distance vector and square
C              distance to particle.
C
C     History: - Creation (12.10.00, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     ATOM   : Local atom.
C     POINT  : Local cube point.
C     RVECTOR: Atomic distance vector.
C     RSQUARE: Square distance.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'molecule.h'
      INCLUDE 'projectile.h'
C
      INTEGER ATOM,ICOOR,POINT
      REAL RSQUARE
C
      REAL RVECTOR(3)
C
C     ------------------------------------------------------------------
C
C     *** Calculate square distance ***
C
      RSQUARE = 0.0
      DO 10 ICOOR=1,3
        RSQUARE = RSQUARE + (COORD(ICOOR,ATOM,CCSET) - 
     $                       CRAD(ICOOR,POINT,CCSET))**2
   10 CONTINUE
C
C     *** Calculate distance vector to embedding cube point ***
C
      ENTRY RADVEC(ATOM,POINT,RVECTOR)
C
      DO 20 ICOOR=1,3
        RVECTOR(ICOOR) = COORD(ICOOR,ATOM,CCSET) -
     $                   CRAD(ICOOR,POINT,CCSET)
   20 CONTINUE
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE CUBEDIS ***
C
      END
