       SUBROUTINE RTMLOUT 
C
C      Purpose: Print data in the deMon.rtp outfile.
C
C      History: Creation (25.07.16, ADLL)
C
C      ****************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'auxis.h'
      INCLUDE 'fileio.h'
      INCLUDE 'flags.h'
      INCLUDE 'molecule.h'
      INCLUDE 'mp_demon.h'
      INCLUDE 'physic.h'
      INCLUDE 'pointer.h'
      INCLUDE 'projectile.h'
      INCLUDE 'property.h'
      INCLUDE 'rtdft.h'
      INCLUDE 'strings.h'
C
      INTEGER I,IATOM,LC,MX,MY,MZ
      REAL DPOLE,GMOL,KMOL,QMOL,LMOL,PS2,QPOLE,SMOL,TIME,TWONPOLE
      REAL COM(3),DIP(3),R(3),TOPMOM(10)
C
      REAL,ALLOCATABLE :: DIST(:),PS(:)
      CHARACTER*24 FORM6
      CHARACTER*25 FORM7
      CHARACTER*26 FORM8
      CHARACTER*32 FORM3
      CHARACTER*33 FORM4
      CHARACTER*34 FORM5
      CHARACTER*47 FORM0
      CHARACTER*48 FORM1
      CHARACTER*49 FORM2
      CHARACTER*80 STRING,SYSTEM
C
C     -----------------------------------------------------------------
C
C     *** Select unit system for topological analysis ***
C
      IF (UNIT(1).EQ.'ANGSTROM') THEN
        DPOLE = ESU(1)
        QPOLE = ESU(2)
        SYSTEM = 'ESU'
      ELSE
        DPOLE = 1.0
        QPOLE = 1.0
        SYSTEM = 'AU'
      END IF
C
C
      TIME = 1.0E3*RTT/FSEC
C     
      IF (MLRT) THEN
        ALLOCATE (PS(NATOM),DIST(NATOM))   
        TIME = RTT - RTSTEP
        CALL SETPROJ(TIME,'NOPRT')
        DO IATOM=1,NATOM
          R(1:3) = COORD(1:3,IATOM,CCSET) - CRAD(1:3,1,CCSET)
          R(1:3) = R(1:3)
          DIST(IATOM) = SQRT(R(1)**2 + R(2)**2 + R(3)**2) 
          IF (FULLPA) THEN
            PS(IATOM) = DOT_PRODUCT(R(1:3),MBASIN(2:4,IATOM))
          END IF
        END DO
        CALL GETCM(NATOM,COORD(1:3,1:NATOM,CCSET),MATOM(1:NATOM),COM)
        R(1:3) = COM(1:3) - CRAD(1:3,1,CCSET)
        R(1:3) = R(1:3)
        PS2 = DOT_PRODUCT(R(1:3),DIP(1:3))
C
        FORM0 = '(2(F12.6,1X),X(F9.5,1X,F8.5,1X,F10.5,1X),F10.5)'
        FORM1 = '(2(F12.6,1X),XX(F9.5,1X,F8.5,1X,F10.5,1X),F10.5)'
        FORM2 = '(2(F12.6,1X),XXX(F9.5,1X,F8.5,1X,F10.5,1X),F10.5)'
        FORM3 = '(2(F12.6,1X),X(F9.5,1X,F8.5,1X))'
        FORM4 = '(2(F12.6,1X),XX(F9.5,1X,F8.5,1X))'
        FORM5 = '(2(F12.6,1X),XXX(F9.5,1X,F8.5,1X))'
        FORM6 = '(2(F12.6,1X),X(F9.5,1X))'
        FORM7 = '(2(F12.6,1X),XX(F9.5,1X))'
        FORM8 = '(2(F12.6,1X),XXX(F9.5,1X))'
C
        IF (FULLPA) THEN
          IF (NATOM.LE.9) THEN
            WRITE(FORM0(14:14),'(I1)') NATOM
            WRITE(MLDAT,FORM0) DERAD*EVOLT, DEPERT*EVOLT,
     $                         ((DIST(IATOM),QATOM(IATOM),
     $                          PS(IATOM)),IATOM=1,NATOM),PS2
          ELSE IF (NATOM.LE.99) THEN
            WRITE(FORM1(14:15),'(I2)') NATOM
            WRITE(MLDAT,FORM1) DERAD*EVOLT,DEPERT*EVOLT,
     $                         ((DIST(IATOM),QATOM(IATOM),
     $                         PS(IATOM)),IATOM=1,NATOM),PS2
          ELSE IF (NATOM.LE.999) THEN
            WRITE(FORM2(14:16),'(I3)') NATOM
            WRITE(MLDAT,FORM2) DERAD*EVOLT,DEPERT*EVOLT,
     $                         ((DIST(IATOM),QATOM(IATOM),
     $                         PS(IATOM)),IATOM=1,NATOM),PS2
          END IF
       ELSE IF (ESA) THEN 
          IF (NATOM.LE.9) THEN
            WRITE(FORM3(14:14),'(I1)') NATOM 
            WRITE(MLDAT,FORM3) DERAD*EVOLT,DEPERT*EVOLT,
     $                         ((DIST(IATOM),QATOM(IATOM))
     $                          ,IATOM=1,NATOM) 
          ELSE IF (NATOM.LE.99) THEN
            WRITE(FORM4(14:15),'(I2)') NATOM
            WRITE(MLDAT,FORM4) DERAD*EVOLT,DEPERT*EVOLT,
     $                         ((DIST(IATOM),QATOM(IATOM))
     $                         ,IATOM=1,NATOM) 
          ELSE IF (NATOM.LE.999) THEN
            WRITE(FORM5(14:16),'(I3)') NATOM
            WRITE(MLDAT,FORM5) DERAD*EVOLT,DEPERT*EVOLT,
     $                         ((DIST(IATOM),QATOM(IATOM))
     $                         ,IATOM=1,NATOM)
          END IF
        ELSE
          IF (NATOM.LE.9) THEN
            WRITE(FORM6(14:14),'(I1)') NATOM
            WRITE(MLDAT,FORM6) DERAD*EVOLT,DEPERT*EVOLT,
     $                         (DIST(IATOM)
     $                          ,IATOM=1,NATOM)
          ELSE IF (NATOM.LE.99) THEN
            WRITE(FORM7(14:15),'(I2)') NATOM
            WRITE(MLDAT,FORM7) DERAD*EVOLT,DEPERT*EVOLT,
     $                         (DIST(IATOM)
     $                         ,IATOM=1,NATOM)
          ELSE IF (NATOM.LE.999) THEN
            WRITE(FORM8(14:16),'(I3)') NATOM
            WRITE(MLDAT,FORM8) DERAD*EVOLT,DEPERT*EVOLT,
     $                         (DIST(IATOM)
     $                         ,IATOM=1,NATOM)
          END IF
        END IF
        DEALLOCATE (PS,DIST)
      END IF
C
C
C     -----------------------------------------------------------------
C
C     *** End of SUNROUTINE RTPOPOUT ***
C
      END
