      SUBROUTINE CAPV(ABSVS,STO,DSTO,VABS,NGPB)
C
C     Purpose: Calculation of absorbing potential contributions from
C              current grid points.
C
C     History: - Creation (12.04.17, ADLL)
C
C     ******************************************************************
C
C     List of local variables:
C     
C     NGPB:  Number of grid points in the current batch.
C     ABSVS: absorbing potential values.
C     ABSVS: Absorbing potential matrix.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'grid.h'
      INCLUDE 'pointer.h'
C
      INTEGER DSTO
      REAL STO(MAXGPB,DSTO),ABSVS(DSTO,DSTO)
C
      REAL VABS(MAXGPB)
C
      INTEGER IATOM,IGP,INEIGH,ISTO,JATOM,JNEIGH,JSTO,NGPB
C
      REAL VSTO(MAXGPB)
C
C     ------------------------------------------------------------------
C
      DO INEIGH=1,NNEIGH
        IATOM = NEIGH(INEIGH)
        DO ISTO=LL(IATOM),UL(IATOM)
          DO IGP=1,NGPB
            VSTO(IGP) = VABS(IGP)*STO(IGP,ISTO)
          END DO
          DO JNEIGH=INEIGH,NNEIGH
            JATOM = NEIGH(JNEIGH)
            DO JSTO=MAX(ISTO,LL(JATOM)),UL(JATOM)
              IF (ISTO.GE.JSTO) THEN
                DO IGP=1,NGPB
                  ABSVS(ISTO,JSTO) = ABSVS(ISTO,JSTO) -
     $                              STO(IGP,JSTO)*VSTO(IGP)
                END DO
              ELSE
                DO IGP=1,NGPB
                  ABSVS(JSTO,ISTO) = ABSVS(JSTO,ISTO) -
     $                              STO(IGP,JSTO)*VSTO(IGP)
                END DO
              END IF
            END DO
          END DO
        END DO
      END DO
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE CAPV ***
C
      END
