      SUBROUTINE NUMCAP(KSA,KSB,DSTO)
C
C     Purpose: Build complex absorbing potential defined in real space
C              using numerical integration. 
C
C     History: - Creation (24.03.17, ADLL)
C
C     ******************************************************************
C
C     List of local variables:
C
C     KSA  : work matrix -> CAP contribution to Alpha Kohn-Sham matrix.
C     KSB  : work matrix -> CAP contribution to Beta Kohn-Sham matrix.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'numint.h'
C
      INTEGER DSTO
      REAL KSA(DSTO,DSTO),KSB(DSTO,DSTO)
C
C     ------------------------------------------------------------------
C
C     *** Generate and save grid for CAP  ***
C
      CALL GRDDEF(CAPGSN,'LOAD-TYPE')
      CALL GRDTHRS
      CALL GRDDRV(KSA,KSB,DSTO)
C
C     *** Calculate absorbing potential contributions ***
C
      KSA(:,:) = 0.0
      KSB(:,:) = 0.0
      CALL NUMCAPDIR(KSA,KSB,DSTO)
C     
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE NUMCAP ***
C
      END
