ccc adll
      subroutine doexpmat(Mat,Mat_back,W,n)

      ! Implicit statement
      implicit none

      ! Arguments
      integer,                 intent(in)  :: n 
      complex, dimension(n,n), intent(in)  :: Mat
      complex, dimension(n,n), intent(out) :: Mat_back
ccc adll
      complex,dimension(n),intent(in)  :: W
ccc adll

      ! Local variables
ccc aai AAi The commented fields were changed to allocatable fields
c      complex,              dimension(n,n)   :: Mat_temp
      integer                                :: i, j
      character(len=1)                       :: jobvl, jobvr
      integer                                :: lda, ldvl, ldvr
c      complex,              dimension(n,n)   :: Vl
c      complex,              dimension(n,n)   :: Vr
      complex, allocatable, dimension(:)     :: Work
      integer                                :: lwork
      real,                 dimension(3*n-2) :: Rwork
      integer                                :: info
c      complex,              dimension(n,n)   :: Mat1, Mat2, Mat3
      integer,              dimension(n)     :: Ipiv

      ! Executable statements
      complex, allocatable, dimension(:,:)   :: Mat_temp
      complex, allocatable, dimension(:,:)   :: Vl
      complex, allocatable, dimension(:,:)   :: Vr
      complex, allocatable, dimension(:,:)   :: Mat1, Mat2, Mat3
      allocate(Mat_temp(n,n),Vl(n,n),Vr(n,n),Mat1(n,n),
     $         Mat2(n,n),Mat3(n,n))


      CALL DEFLUSH(6)

      ! Copy Mat to Mat_temp
      Mat_temp(:,:) = Mat(:,:)
      CALL DEFLUSH(6)

      ! Compute right eigenvalues and eigenvectors
      jobvl = 'N'
      jobvr = 'V'

      ! No margin
      lda  = n
      ldvl = n
      ldvr = n

      ! Eigenvalues and eigenvectors computation

      ! Workspace allocation
      lwork = -1
      allocate(Work(1))
      CALL DEFLUSH(6)
 
      call zgeev(jobvl, jobvr, n, Mat_temp, lda, W, Vl, ldvl, Vr, ldvr,
     $  Work, lwork, Rwork, info)
      if (info /= 0) then
        write(700,*) 'Error in zgeev, preparation step', info
        stop 1
      end if
      CALL DEFLUSH(6)

      lwork = nint(real(Work(1)))
      deallocate(Work)
      allocate(Work(lwork))

      ! Real computation
      CALL DEFLUSH(6)

      call zgeev(jobvl, jobvr, n, Mat_temp, lda, W, Vl, ldvl, Vr, ldvr,
     $  Work, lwork, Rwork, info)
      if (info /= 0) then
        write(700,*) 'Error in zgeev, computation step', info
        stop 1
      end if

      ! Compute the inverse of matrix Vr

      ! First factorize it

      Vl(:,:) = Vr(:,:)
C            write(700,*) 'doexpomat 3'
      CALL DEFLUSH(6)

      call zgetrf(n, n, Vl, n, Ipiv, info)
      if (info /= 0) then
        write(700,*) 'Error in zgetrf', info
        stop 1
      end if

      ! Then perform the inversion

      ! Workspace allocation
      lwork = -1
      call zgetri(n, Vl, n, Ipiv, Work, lwork, info)
      if (info /= 0) then
        write(700,*) 'Error in zgetri, preparation step', info
        stop 1
      end if
C        write(700,*) 'doexpomat 4'
      CALL DEFLUSH(6)

      lwork = nint(real(Work(1)))
      deallocate(Work)
      allocate(Work(lwork))

      ! Real computation
      call zgetri(n, Vl, n, Ipiv, Work, lwork, info)
      if (info /= 0) then
        write(700,*) 'Error in zgetri, computation step', info
        stop 1
      end if

      ! Exponential matrix
      Mat1(:,:) = Vr(:,:)
      Mat3(:,:) = Vl(:,:)
      Mat2(:,:) = 0
      do i = 1, n
        Mat2(i,i) = exp(W(i))
      end do
      Mat_back(:,:) = matmul(Mat1(:,:), Mat2(:,:))
      Mat2(:,:) = Mat_back(:,:)
      Mat_back(:,:) = matmul(Mat2(:,:), Mat3(:,:))

      deallocate(Mat_temp,Vl,Vr,Mat1,Mat2,Mat3)

      end
