      SUBROUTINE GETEPROJ(PA,PB,H,DSTO)
C
C     Purpose: calculate energy terms involving projectile. 
C
C     History -Creation (03.03.20,ADLL)
C
C     *****************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'dynamics.h'
      INCLUDE 'flags.h'
      INCLUDE 'molecule.h'
      INCLUDE 'mm.h'
      INCLUDE 'mp_demon.h'
      INCLUDE 'physic.h'
      INCLUDE 'projectile.h'
      INCLUDE 'rtdft.h'
C
      INTEGER DSTO
      REAL H(DSTO,DSTO),PA(DSTO,DSTO),PB(DSTO,DSTO)
C
      INTEGER I,IATOM,IRAD,JATOM,JLIMIT,KATOM
      REAL ANG,ANGLE,CLAU,D,FACTOR,MC2,TRACE,BETA
      REAL R(3)
      LOGICAL MPP_SAVE
      INTEGER OFFSET
C
C     -----------------------------------------------------------------
C
      ERADIA(:) = 0.0
      MC2 = MRAD*AMU*(CLIGHT/(ABOHR*FSEC*1.E15))**2
      CLAU = CLIGHT/(ABOHR*FSEC*1.E15)
      BETA = SQRT(1-(KINRAD/MC2 + 1)**(-2))
C
C     *** Interaction of rad. particle with electron cloud ***
C
      CALL SCFIO(H,DSTO,'READ','RADIAF')
      ERADIA(1) = ERADIA(1) + TRACE(PA,H,DSTO,NSTO,'LOWERA')
      IF (OKS) ERADIA(1) = ERADIA(1) + TRACE(PB,H,DSTO,NSTO,'LOWERA')
C
C     *** Interaction of rad. particle with QM nuclei ***
C
      DO IATOM=1,NATOM
        DO IRAD=1,NRADP
          D = 0.0
          DO I=1,3
            R(I) = COORD(I,IATOM,CCSET)-CRAD(I,IRAD,CCSET)
            D = D + R(I)**2
          END DO
          IF (USELWP) THEN
            ANG= ANGLE(R(1),R(2),R(3),
     $           VIORAD(1,IRAD),VIORAD(2,IRAD),VIORAD(3,IRAD))
            FACTOR = (1. - ((BETA*SIN(ANG))**2))**0.5
            FACTOR = 1./FACTOR
          ELSE
            FACTOR = 1.0
          END IF
          ERADIA(2) = ERADIA(2) + FACTOR*ZATOM(IATOM)*QRAD(IRAD)/SQRT(D)
        END DO
      END DO
C
C     *** Interaction energy of projectile with MM permanent charges
C
      IF (QMMM) THEN
        JLIMIT = NATOM_ALL
        DO JATOM=NATOM+1,JLIMIT,1
          KATOM = JATOM - NATOM
          DO IRAD=1,NRADP
            D = 0.0
            DO I=1,3
              R(I) = COORD(I,IATOM,CCSET)-CRAD(I,IRAD,CCSET)
              D = D + R(I)**2
            END DO
            IF (USELWP) THEN
              ANG = ANGLE(R(1),R(2),R(3),
     $             VIORAD(1,IRAD),VIORAD(2,IRAD),VIORAD(3,IRAD))
              FACTOR = (1. - ((BETA*SIN(ANG))**2))**0.5
              FACTOR = 1./FACTOR
            ELSE
              FACTOR = 1.0
            END IF
            ERADIA(2) = ERADIA(2) 
     $                 + FACTOR*CHGMM(KATOM)*QRAD(IRAD)/SQRT(D)
          END DO
        END DO
      END IF      
ccc
C     -----------------------------------------------------------------
C
C     *** End of SUBROUTINE GETERADIA ***
C
      END
