      REAL FUNCTION NUCEMBED() 
ccc aai AAI
ccc The purpose is to calculate, separatedly, the QM/MM nuclei electrostatics
ccc   for report purposes. Apart from checking consistency, it has to be
ccc   checked what other energy terms may be calculated separatedly.
ccc aai AAI
C
C     Purpose: Calculates the NUClear repulsion energy between QM and MM
C              (EMBEDding) atoms only.
C
C     History: - Creation (26.03.96, AMK)
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'embed.h'
      INCLUDE 'flags.h'
      INCLUDE 'mm.h'
      INCLUDE 'mmpot.h'
      INCLUDE 'molecule.h'
      INCLUDE 'qmmm.h'
      INCLUDE 'projectile.h'
      INCLUDE 'dynamics.h'
C
      INTEGER IATOM,JATOM,JEMBED,KATOM
      REAL D
C
      REAL R(3)
      INTEGER JLIMIT
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
      NUCEMBED = 0.0
C
C     *** Add QM/MM point charge Coulomb energy ***
C
      JLIMIT = NATOM_ALL
C
      IF (QMMM) THEN
        DO 40 IATOM=1,NATOM
          DO 30 JATOM=NATOM+1,JLIMIT,1
            KATOM = JATOM - NATOM
            CALL ATOMDIS(JATOM,IATOM,R,D)
            NUCEMBED = NUCEMBED + ZATOM(IATOM)*CHGMM(KATOM)/SQRT(D)
   30     CONTINUE
   40   CONTINUE
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of REAL FUNCTION NUCREP ***
C
      END
