      SUBROUTINE READEFIELD(STRING)
C
C     Purpose: Read electric field components.
C
C     History: - Creation (01.01.18, ADLL)
C
C     ******************************************************************
C
      IMPLICIT NONE 
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'embed.h'
C
      CHARACTER*(*) STRING
C
      INTEGER BAR,COMMA1,COMMA2,EQUAL
      CHARACTER*80 PRTSTR,STRCOMP
C
C     ------------------------------------------------------------------
C
C     *** Initialize ***
C
      ELFIELD(:) = 0.0
C
      EQUAL = INDEX(STRING,'=')
      IF (EQUAL.NE.2) GO TO 99990
C
C     *** Read electric field components ***
C
      COMMA1 = INDEX(STRING,';')
      READ(STRING(EQUAL+2:COMMA1-1),*,ERR=99990) ELFIELD(1)
      COMMA2 = INDEX(STRING(COMMA1+1:),';') 
      COMMA2 = COMMA2 + COMMA1
      READ(STRING(COMMA1+1:COMMA2-1),*,ERR=99990) ELFIELD(2)
      BAR = INDEX(STRING,')')
      READ(STRING(COMMA2+1:BAR-1),*,ERR=99990) ELFIELD(3)
C
      RETURN
C
C     *** Handling of read errors ***
C
99990 CONTINUE
      WRITE (PRTSTR,99995) 
99995 FORMAT ('ERROR READING ELECTRIC FIELD COMPONENTS')
      CALL ERRMSG('READEFIELD',STRCOMP(PRTSTR),1)
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE READEFIELD *** 
C
      END
