      SUBROUTINE COUNTEL(PA,PB,DSTO_ME,NELKS,NELAUX)
C
C     Purpose: Count electron number in RTDFT. 
C
C     History: - Creation (29.10.15, XJ)
C
C     ******************************************************************
C     List of local dimensions:
C
C     DSTO_ME  : Dimension of MATRIX.
C
C     List of local variables:
C
C     NELAUX: Integrated auxiliary density. 
C     NELKS : Integrated Kohn-Sham density.
C     PA    : Alpha density matrix.    
C     PB    : Beta density matrix
C      
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C     
      INCLUDE 'parameter.h'
C
      INCLUDE 'auxis.h'
      INCLUDE 'fileio.h'
      INCLUDE 'flags.h'
      INCLUDE 'molecule.h'
      INCLUDE 'rtdft.h'
C
      INTEGER ALLOCATION,DSTO_ME
      REAL NELAUX,NELKS,TRACE
      REAL PA(DSTO_ME,DSTO_ME),PB(DSTO_ME,DSTO_ME)
C
      INTEGER IAUX
      REAL,ALLOCATABLE :: S(:,:)
C
C     ------------------------------------------------------------------
C
C     *** Allocate dynamic arrays ***
C
      ALLOCATE(S(DSTO_ME,DSTO_ME),STAT=ALLOCATION)
      S(:,:) = 0.0
      CALL SCFIO(S,NSTO,'READ','OVERLAP')
C
C     *** Calculate electron number ***
C
      NELA = 0.0
      NELB = 0.0
      NELAUX = 0.0
C
      NELA = TRACE(PA,S,DSTO_ME,DSTO_ME,'LOWERA')
      IF (OKS) NELB = TRACE(PB,S,DSTO_ME,DSTO_ME,'LOWERA')
C
      DO IAUX=1,NAUX
        NELAUX = NELAUX + FCDA(IAUX)*QAUX(IAUX)
        IF (OKS) NELAUX = NELAUX + FCDB(IAUX)*QAUX(IAUX)
      END DO
      NELKS = NELA + NELB
      NELCD = NELAUX
C
C     *** Deallocate dynamical field ***
C
      DEALLOCATE(S,STAT=ALLOCATION)
C      
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE COUNTEL ***
C
      END
