      SUBROUTINE GETCM(NAATOM,MOLECULE,WEIGHT,CM)
C
C     Purpose: Get (weighted) center of mass of MOLECULE.
C
C     History: - Creation (27.03.08, JMVP)
C                         (05.06.12, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     MOLECULE: Molecular coordinates.
C     NAATOM:   Number of active atoms.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'molecule.h'
C
      REAL MOLECULE(3,NAATOM),WEIGHT(NAATOM)
C
      INTEGER I,IATOM,NAATOM
      REAL MOLMASS
C
      REAL CM(3)
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
      CM(:) = 0.0
C
C     *** Sum atomic masses ***
C
      MOLMASS = 0.0
C
      DO IATOM=1,NAATOM
        MOLMASS = MOLMASS + WEIGHT(IATOM)
      END DO
C
C     *** Calculate center of mass shift vector ***
C
      DO I=1,3
        DO IATOM=1,NAATOM
          CM(I) = CM(I) + WEIGHT(IATOM)*MOLECULE(I,IATOM)
        END DO
        CM(I) = CM(I)/MOLMASS
      END DO
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE GETCM ***
C
      END
