      SUBROUTINE STOPMAT(A,B,C,DMAT,OPTION)
C
C     Purpose: interface routine to handle saving of complex density
C     matrices.
C
C     History: (creation 14.10.16, ADLL)
C
C     *****************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
      INCLUDE 'mp_demon.h'
C
      INTEGER DMAT
      REAL A(DMAT,DMAT),B(DMAT,DMAT),C(DMAT,DMAT)
      CHARACTER*(*) OPTION
C   
      INTEGER I,J
C
C     -----------------------------------------------------------------
C
C     *** Store real (B) and imaginary (C) parts in A ***
C
      IF (OPTION.EQ.'REDUCE') THEN
C
        DO J=1,DMAT
          DO I=J,DMAT
            A(I,J) = B(I,J)
          END DO
        END DO
        DO J=1,DMAT
          DO I=1,J-1
             A(I,J) = C(I,J)
          END DO
        END DO
C
C     *** Expand A into real (B) and imaginary (C) matrices ***
C
      ELSE IF (OPTION.EQ.'EXPAND') THEN
C
        DO J=1,DMAT
          DO I=J,DMAT
            B(I,J) = A(I,J)
          END DO
        END DO
        DO J=1,DMAT
          DO I=1,J-1
            C(I,J) = A(I,J)
          END DO
        END DO
        CALL SYMMAT(B,DMAT,DMAT,'LOWUP')
        CALL SYMMAT(C,DMAT,DMAT,'-UPLOW')
        CALL SCALMAT(C,DMAT,DMAT,DMAT,'M = N',0.0) 
C 
      END IF
C
C     -----------------------------------------------------------------
C
C     *** End of SUBROUUTINE STOREPMAT ***
C
      END
        
