      SUBROUTINE TOPINI
C
C     Purpose: Initialize topological population analysis.
C
C     History: - Creation (24.06.07, AMK)
C                         (14.10.10, GG)
C
C     ******************************************************************
C
C     List of local variables:
C
C     DIRTOP: If true, a direct topological integration is requested.
C     G98TOP: Flag for G98 topological analysis fixed grid type.
C     REFTOP: If true, reference setting for topological integration.
C     
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'grid.h'
      INCLUDE 'property.h'
      INCLUDE 'xc.h'
C
C     ------------------------------------------------------------------
C
C     *** Initialize topological grid ***
C
      NGPFAIL = 0
      NGPZERO = 0
C
      DIRGRD = DIRTOP
      G98TYP = G98TOP
      REFGRD = REFTOP
C
      GRDTYP = 'FIXED'
      RADQUA = 'EULER-MACLAURIN'
      ROTGRD = .FALSE.
      RETGRD = .FALSE.
      INITLEB = .TRUE.
C
C     *** Initialize molecular properties ***
C
      RHOSUM = 0.0
C
C     *** Initialize atomic properties ***
C
      GBASIN(:) = 0.0
      KBASIN(:) = 0.0
      LBASIN(:) = 0.0
      MBASIN(:,:) = 0.0
      NBASINA(:) = 0.0
      NBASINB(:) = 0.0
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE TOPINI ***
C
      END
