      SUBROUTINE WFNGEO(TITLE)
C
C     Purpose: Write header and geometry for WFN file output.
C
C     History: - Creation (12.08.08, ADLL)
C                         (18.03.09, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     TITLE: WFN file title.
C     
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'fileio.h'
      INCLUDE 'flags.h'
      INCLUDE 'molecule.h'
      INCLUDE 'pointer.h'
CCC ADLL 
      INCLUDE 'projectile.h'
CCC ADLL
      INCLUDE 'scfvec.h'
C
      CHARACTER*(*) TITLE
      INTEGER IATOM,ICOOR,NOMO,NPTO
C
      INTEGER DIMPTO
C
C     ------------------------------------------------------------------
C
C     *** Write WFN file title ***
C
      WRITE (MOL,'(A)') TITLE
C
C     *** Write header line ***
C
      NOMO = NOMOA
      IF (OKS) NOMO = NOMO + NOMOB
      NPTO = DIMPTO(NSHL,NCO,SHLPTR)
C
CCC ADLL
      WRITE (MOL,5000) NOMO,NPTO,NATOM + NRADP 
CCC ADLL
C
C     *** Write molecular geometry ***
C
      DO IATOM=1,NATOM
        WRITE (MOL,5010) ATOMLAB(IATOM),IATOM,IATOM,(COORD(ICOOR,
     $                   IATOM,CCSET),ICOOR=1,3),REAL(ZATOM(IATOM))
      END DO
C
C     ------------------------------------------------------------------
C
C     *** Format statements ***
C
 5000 FORMAT ('GAUSSIAN',I15,' MOL ORBITALS',I7,' PRIMITIVES',I9,
     $        ' NUCLEI')
 5010 FORMAT (2X,A2,I4,4X,'(CENTRE ',I3,')',1X,3(F12.8,1X),
     $        'CHARGE =',F5.1)
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE WFNGEO ***
C
      END
