C     MMPOT COMMON
C
C     Purpose: Common definition for mmpot.
C
CTODO
CTODO Should be unified with mm.h!
CTODO
C
C     History: - Creation (05.10.09, AG) 
C                         (13.11.14, GG)
C
C     ******************************************************************
C
C     List of variables:
C
C     DOBOND     : Uses the bond stretching potential
C     DOBANG     : Uses the bond bending potential
C     DOUREY     : Uses the Urey - Bradley potential
C     DOTORS     : Uses the torsion potential
C     DOIMPTORS  : Uses the improper- torsion term     
C     DOCHARGE   : Uses the charge electrostatic term only
C     DOVDW      : Uses the Van der Waals potential
C 
C     Not activated:
C     DOIMPROPTORS : Improper torsion used in Amber, OPLS
C     DOBANGBANG   : Bending - bending term used in MM3
C     DOBONDTORSION: Bond - torsion term used in MM3
C     DODIPOLE     : Electrostatic term used in MM3
C     DOSOLVENT    : Uses a dielectric continuum for solvent.
C     DOGEOM       : Used  to restrain some atoms
C                    in a specific space.(kgeom in Tinker).
C
CCC ADLL
C     LINKATLINE   : Number of lines defining LA parameters in FFDS.
CCC ADLL

C
C
C     ------------------------------------------------------------------
C
C     *** Common block for Logical variables ***
C
      LOGICAL DOBANG,DOBOND,DOCHARGE,DOIMPTORS,
     $        DOTORS,DOUREY,DOVDW
C
C     *** Common block for Logical variables ***
C
      COMMON /MMPOTL/ DOBANG,DOBOND,DOCHARGE,DOIMPTORS,
     $                DOTORS,
     $                DOUREY,DOVDW
C
C     *** Common block for Character variables ***
C
      CHARACTER*13 BONDTYPE,EPSRULE,GAUSSTYPE,RADRULE,RADSIZ,RADTYPE,
     $             VDWTYPE
C
      CHARACTER*13 BANGTYPE(MAXBANG)
C
C     *** Common block for Character variables ***
C
      COMMON /MMPOTC/ BANGTYPE,BONDTYPE,EPSRULE,GAUSSTYPE,RADRULE,
     $                RADSIZ,RADTYPE,VDWTYPE
C
C     *** Common block for REAL variables ***
C
      REAL ABUCK,BBUCK,CBUCK,CHGCUT,CHGSWITCH,CUBBANG,CUBBND,CUBUREY,
     $     DIELEC,IMPTORSUNIT,PENBANG,QUABANG,QUABND,QUAUREY,
     $     SEXBANG,TORSUNIT,VDWCUT,VDWSWITCH
C
      COMMON /MMPOTR/ ABUCK,BBUCK,CBUCK,CHGCUT,CHGSWITCH,CUBBANG,CUBBND,
     $                CUBUREY,DIELEC,IMPTORSUNIT,PENBANG,
     $                QUABANG,QUABND,QUAUREY,SEXBANG,TORSUNIT,VDWCUT,
     $                VDWSWITCH
C
C     *** Common block for INTEGER variables ***
C
      INTEGER ANGLELINES,ATOMLINES,
CCC ADLL LA
     $        LINKATLINES,
CCC ADLL LA
     $        BIOTYPLINES,BONDLINES,CHARGELINES,
     $        IMPTORLINES,KEYWLINES,
     $        TORSIONLINES,UREYLINES,VDWLINES
C
      COMMON /MMPOTI/ ANGLELINES,ATOMLINES,
CCC ADLL LA
     $        LINKATLINES,
CCC ADLL LA
     $        BIOTYPLINES,BONDLINES,
     $                CHARGELINES,IMPTORLINES,KEYWLINES,
     $                TORSIONLINES,UREYLINES,VDWLINES
C
C     ------------------------------------------------------------------
