C     QMMM COMMON
C
C     Purpose: Common definition for qmmm.     
C
C     History: - Creation (28.07.10, AG) 
C                         (13.11.14, GG)
C
C     ******************************************************************
C
C     List of variables:
C
CCC ADLL
C     EPCQM : Interaction energy between MM point charge and QM region.
CCC ADLL
C     QMMMFF: Name of the Force Field used for QM-MM
C     TYPEQM: Type of each QM atom.
C     NTYPQM: Number of QM Atom Types.
C     LABTYPQM: Label of the QM Atom defining the Type
C     RMINQM: Value of the RMIN parameter assigned to this QM atom
C     EPSQM: Value of the EPS parameter assigned to this QM atom
CCC ADLL LA
C     NLATOM : Number of link atoms.
C     LINKAT : If true, link atoms are present in QM/MM.
C     LATR   : Bond length ratio of cut bond to position link atom.
C     LATC   : Capping potential parameter.
C     LATQM  : Connector list for border QM/MM covalent bonds.
C              Entry 1: atom pertaining to QM region.
C              Entry 2: atom pertaining to MM region.
C              Entry 3: link atom.
C     LINKLA : List of QM atoms connected to the frontier QM atom.
C     QMLNKTY: QM atom types of the frontier atoms
CCC ADLL LA
C
C     ------------------------------------------------------------------
C
CCC ADLL LA
C     *** Common block for Logical variables ***
C
      LOGICAL DAQMMM,LINKAT
C
C     *** Common block for Logical variables ***
C
      COMMON /QMMML/ DAQMMM,LINKAT
CCC ADLL LA
C     *** Common block for CHARACTER variables ***
C
      CHARACTER*10 QMMMFF
C
      CHARACTER*10 LABTYPQM(MAXATOM) 
CCC ADLL LA
      CHARACTER*1 LATSYM
CCC ADLL LA
C
      COMMON /CQMMM/ LABTYPQM,QMMMFF
CCC ADLL LA
     $             , LATSYM
CCC ADLL LA
C
C     *** Common block for REAL variables ***
C
CCCC ADLL
      REAL EPCQM
CCC ADLL
      REAL C12QM(MAXATOM),C6QM(MAXATOM),
CCC ADLL LA
     $     LATR(MAXTYPE),LATC(MAXTYPE),
CCC ADLL LA
     $     VEPSQM(MAXTYPE),
     $     VLJEPSQM(MAXATOM),VLJRADQM(MAXATOM),
     $     VRADQM(MAXTYPE)
C
      COMMON /RQMMM/ C12QM,C6QM,
CCC ADLL LA
     $               LATR,LATC,
CCC ADLL LA
     $               VEPSQM,VLJEPSQM,
     $               VLJRADQM,VRADQM
CCC ADLL
     $              ,EPCQM
C
C     *** Common block for INTEGER variables ***
C
      INTEGER NATOMVDW,
CCC ADLL LA
     $        NLATOM,
CCC ADLL LA
     $        NQMCLASS,NTYPQM
C
      INTEGER ATQMVDW(MAXATOM),CLASSOFTYP2(MAXTYPE),CLASS2(MAXCLASS),
CCC ADLL LA
     $        LATQM(MAXATMM,3),LINKLA(MAXLNKAT,0:MAXLINK),
     $        QMLNTYPE(MAXLINK*MAXLNKAT),
CCC ADLL LA
     $        QMCLASS(MAXATOM),TYPEQM(MAXATOM)
C
      COMMON /IQMMM/ ATQMVDW,CLASSOFTYP2,CLASS2,
CCC ADLL LA
     $                 LATQM,LINKLA,QMLNTYPE,
CCC ADLL LA
     $               NATOMVDW,
CCC ADLL LA
     $                  NLATOM,
CCC ADLL LA
     $                 NQMCLASS,
     $               NTYPQM,QMCLASS,TYPEQM
C
C     ------------------------------------------------------------------
