      SUBROUTINE ATOMRHO(WATOM,LLGPB,NGPB,NSPIN)
C
C     Purpose: ADD RHO values of the current batch of grid points to
C              the atomic populations and moments.
C
C     History: - Creation (20.08.12, AMK)
C                         (20.06.16, AMK)
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'grid.h'
      INCLUDE 'molecule.h'
      INCLUDE 'property.h'
      INCLUDE 'xc.h'
C
      INTEGER NSPIN
      REAL WATOM(MAXGPB,NATOM,NSPIN)
C
      INTEGER IATOM,IGP,LLGPB,NGPB
      REAL X,Y,Z,WEIGHT
C
C     ------------------------------------------------------------------
C
C     *** Loop over all atoms ***
C
      DO 20 IATOM=1,NATOM
C
C     *** Loop over all grid points in current batch ***
C
        DO 10 IGP=1,NGPB
C
          WEIGHT = GRDVEC(4,LLGPB+IGP-1)
C
C     *** Sum electron density ***
C
          NBASINA(IATOM) = NBASINA(IATOM) + WATOM(IGP,IATOM,1)*
     $                     WEIGHT*RHOA(IGP)
C
CCC ADLL
          IF (TDEKIN) THEN
            KBASIN(IATOM) = KBASIN(IATOM) - 0.5*WEIGHT*D1RHOA(IGP,1)*
     $                                      WATOM(IGP,IATOM,1)
            GBASIN(IATOM) = GBASIN(IATOM) + 0.5*WEIGHT*D1RHOA(IGP,2)*
     $                                      WATOM(IGP,IATOM,1)
            LBASIN(IATOM) = LBASIN(IATOM) - 0.25*WEIGHT*D1RHOA(IGP,3)*
     $                                      WATOM(IGP,IATOM,1)
          END IF
CCC ADLL
C
          IF (OKS) THEN
            NBASINB(IATOM) = NBASINB(IATOM) + WATOM(IGP,IATOM,NSPIN)*
     $                       WEIGHT*RHOB(IGP)
CCC ADLL
            IF (TDEKIN) THEN
              KBASIN(IATOM) = KBASIN(IATOM) - 0.5*WEIGHT*D1RHOB(IGP,1)*
     $                                        WATOM(IGP,IATOM,1)
              GBASIN(IATOM) = GBASIN(IATOM) + 0.5*WEIGHT*D1RHOB(IGP,2)*
     $                                        WATOM(IGP,IATOM,1)
              LBASIN(IATOM) = LBASIN(IATOM) - 0.25*WEIGHT*D1RHOB(IGP,3)*
     $                                        WATOM(IGP,IATOM,1)
CCC ADLL
            END IF
          END IF
C
C     *** Sum electrostatic moments ***
C
          IF (FULLPA) THEN
C
            X = GRDVEC(1,LLGPB+IGP-1) - COORD(1,IATOM,CCSET)
            Y = GRDVEC(2,LLGPB+IGP-1) - COORD(2,IATOM,CCSET)
            Z = GRDVEC(3,LLGPB+IGP-1) - COORD(3,IATOM,CCSET)
            WEIGHT = GRDVEC(4,LLGPB+IGP-1)*WATOM(IGP,IATOM,1)
C
            MBASIN(2,IATOM) = MBASIN(2,IATOM) - X*WEIGHT*RHOA(IGP)
            MBASIN(3,IATOM) = MBASIN(3,IATOM) - Y*WEIGHT*RHOA(IGP)
            MBASIN(4,IATOM) = MBASIN(4,IATOM) - Z*WEIGHT*RHOA(IGP)
            MBASIN(5,IATOM) = MBASIN(5,IATOM) - X*X*WEIGHT*RHOA(IGP)
            MBASIN(6,IATOM) = MBASIN(6,IATOM) - X*Y*WEIGHT*RHOA(IGP)
            MBASIN(7,IATOM) = MBASIN(7,IATOM) - X*Z*WEIGHT*RHOA(IGP)
            MBASIN(8,IATOM) = MBASIN(8,IATOM) - Y*Y*WEIGHT*RHOA(IGP)
            MBASIN(9,IATOM) = MBASIN(9,IATOM) - Y*Z*WEIGHT*RHOA(IGP)
            MBASIN(10,IATOM) = MBASIN(10,IATOM) - Z*Z*WEIGHT*RHOA(IGP)
C
            IF (OKS) THEN
              WEIGHT = GRDVEC(4,LLGPB+IGP-1)*WATOM(IGP,IATOM,NSPIN)
              MBASIN(2,IATOM) = MBASIN(2,IATOM) - X*WEIGHT*RHOB(IGP)
              MBASIN(3,IATOM) = MBASIN(3,IATOM) - Y*WEIGHT*RHOB(IGP)
              MBASIN(4,IATOM) = MBASIN(4,IATOM) - Z*WEIGHT*RHOB(IGP)
              MBASIN(5,IATOM) = MBASIN(5,IATOM) - X*X*WEIGHT*RHOB(IGP)
              MBASIN(6,IATOM) = MBASIN(6,IATOM) - X*Y*WEIGHT*RHOB(IGP)
              MBASIN(7,IATOM) = MBASIN(7,IATOM) - X*Z*WEIGHT*RHOB(IGP)
              MBASIN(8,IATOM) = MBASIN(8,IATOM) - Y*Y*WEIGHT*RHOB(IGP)
              MBASIN(9,IATOM) = MBASIN(9,IATOM) - Y*Z*WEIGHT*RHOB(IGP)
              MBASIN(10,IATOM) = MBASIN(10,IATOM) - Z*Z*WEIGHT*RHOB(IGP)
            END IF
C
          END IF
C
   10   CONTINUE
C
   20 CONTINUE
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE ATOMRHO ***
C
      END
