      SUBROUTINE GRDDEF(GST,OPTION)
C
C     Purpose: store and load grid sets parameters.
C
C     History: - Creation (24.08.16, ADLL)
C
C     ******************************************************************
C
C     List of local variables:
C
C     GST : Grid set number.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'grid.h'
CCC ADLL (For option SEND_ALL)
      INCLUDE 'mp_demon.h'
CCC ADLL
      INCLUDE 'numint.h'
CCC ADLL
      INCLUDE 'rtdft.h'
CCC ADLL
      INCLUDE 'tolerance.h'
C
      INTEGER GST
      CHARACTER*(*) OPTION
C
      LOGICAL SUCCESS,DIRGRD_FRQ
      INTEGER NOPTION
C
      CHARACTER*80 OPTIONS(MAXOPT)
C
C     ------------------------------------------------------------- 
C
      IF (OPTION.EQ.'LOAD') THEN
C
        LLGP(:) = LLGP_GST(:,GST) 
        LRADIAL(:,:) = LRADIAL_GST(:,:,GST)
        NRADIAL(:) = NRADIAL_GST(:,GST)
        ULGP(:) = ULGP_GST(:,GST)
C
      ELSE IF (OPTION.EQ.'STORE') THEN
C
        LLGP_GST(:,GST) = LLGP(:)
        LRADIAL_GST(:,:,GST) = LRADIAL(:,:)
        NRADIAL_GST(:,GST) = NRADIAL(:)
        ULGP_GST(:,GST) = ULGP(:)
C
        RETGRD_GST(GST) = .TRUE. 
C
      ELSE IF (OPTION.EQ.'LOAD-TYPE') THEN
C
        IF (GST.EQ.XCGSN) THEN
C
          CALL FINDKEY('GRID',SUCCESS)
          IF ((STATUS.EQ.'FREQ').OR.(STATUS.EQ.'HESSIAN').OR.
     $        (STATUS.EQ.'UPDATE')) THEN
            DIRGRD_FRQ = DIRGRD
            CALL DEFAULT('GRID',SUCCESS)
            DIRGRD = DIRGRD_FRQ
          ELSE
            CALL DEFAULT('GRID',SUCCESS)
          END IF
          IF (SUCCESS) THEN
            CALL FINDOPT('GRID',OPTIONS,NOPTION)
            CALL DECODE('GRID',OPTIONS,NOPTION)
          END IF
C
          CALL FINDKEY('WEIGHTING',SUCCESS)
          CALL DEFAULT('WEIGHTING',SUCCESS)
          IF (SUCCESS) THEN
            CALL FINDOPT('WEIGHTING',OPTIONS,NOPTION)
            CALL DECODE('WEIGHTING',OPTIONS,NOPTION)
          END IF
C
C     *** Reset quadrature options ***
C
          CALL FINDKEY('QUADRATURE',SUCCESS)
          CALL DEFAULT('QUADRATURE',SUCCESS)
          IF (SUCCESS) THEN
            CALL FINDOPT('QUADRATURE',OPTIONS,NOPTION)
            CALL DECODE('QUADRATURE',OPTIONS,NOPTION)
          END IF
C
        ELSE IF (GST.EQ.TOPGSN) THEN
C
CCC ADLL MODIFIED WRT 612 TO HANDLE ADAPT TOPOLOGICAL GRIDS 
          DIRGRD = .TRUE. 
          GRDTYP = GRDTTYP
          REFGRD = REFTOP
          NRADGRD = NRADTGRD
          GRDTOL = GRDTTOL
          G98TYP = G98TOP
          IF (GRDTTYP.EQ.'FIXED') THEN
            RADQUA = 'EULER-MACLAURIN'
          ELSE
            RADQUA = 'GAUSS-CHEBYSHEV'
          END IF
          ROTGRD = .FALSE.
          INITGRD = .TRUE.
          INITLEB = .TRUE.
          WEIGHTS = 'BECKE'
CCC ADLL
CCC ADLL Block for fixed gris for absorbing potential (RT-TDDFT)
C
        ELSE IF (GST.EQ.CAPGSN) THEN
C
          DIRGRD = .TRUE.
          GRDTYP = 'FIXED'
          REFGRD = REFABS
          G98TYP = G98ABS
          RADQUA = 'EULER-MACLAURIN'
          ROTGRD = .FALSE.
          INITLEB = .TRUE.
          WEIGHTS = 'BECKE'
C
        END IF
CCC ADLL
CCC ADLL This option is needed to restart RT-TDDFT simulations 
      ELSE IF (OPTION.EQ.'SEND_ALL') THEN
C
        CALL MP_SEND_ALL(LLGP_GST(:,GST),MAXATOM,MASTER,MP_INT)
        CALL MP_SEND_ALL(LRADIAL_GST(:,:,GST),MAXATOM*MAXRAD,
     $                   MASTER,MP_INT)
        CALL MP_SEND_ALL(NRADIAL_GST(:,GST),MAXATOM,MASTER,MP_INT)
        CALL MP_SEND_ALL(ULGP_GST(:,GST),MAXATOM,MASTER,MP_INT)
C
CCC ADLL
      ELSE
C
        CALL ERRMSG('GRDDEF','UNKNOWN OPTION',1)
C
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE GRDDEF ***
C
      END
