      LOGICAL FUNCTION NOTIN(KEYWORD,OPTION)
C
C     Purpose: NOTIN checks for hidden keyword options.
C
C     History: - Creation (20.04.11, AMK)
C                         (17.11.17, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     KEYWORD: Input keyword.
C     OPTION : Option to be checked.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      CHARACTER*(*) KEYWORD,OPTION
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
      NOTIN = .TRUE.
C
C     *** Check hidden ROKS SCF options ***
C
      IF (KEYWORD.EQ.'SCFTYPE') THEN
C
        IF (OPTION(1:5).EQ.'GUEST') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'ROOTH') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'DAVID') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'BINKL') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'MCWEE') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'FAEGR') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'PLAKH') NOTIN = .FALSE.
C
C     *** Check hidden exchange-correlation options ***
C
      ELSE IF (KEYWORD.EQ.'VXCTYPE') THEN
C
        IF (OPTION(1:5).EQ.'AUXIS') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'BASIS') NOTIN = .FALSE.
C
C     *** Check hidden grid options ***
C
      ELSE IF (KEYWORD.EQ.'GRID') THEN
C
        IF (OPTION(1:5).EQ.'ADAPT') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'DIREC') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'FIXED') NOTIN = .FALSE.
        IF (OPTION(1:4).EQ.'RAD=') NOTIN = .FALSE.
C
CCC ADLL
C     *** Check hidden propagator options ***
C
      ELSE IF (KEYWORD.EQ.'PROPAGATOR') THEN
        IF (OPTION(1:4).EQ.'TOL=') NOTIN = .FALSE.
        IF (OPTION(1:4).EQ.'CDF=') NOTIN = .FALSE.
C
CCC ADLL
C     *** Check hidden polarizability options ***
C
      ELSE IF (KEYWORD.EQ.'POLARIZABILITY') THEN
C
        IF (OPTION.EQ.'CM^-1') NOTIN = .FALSE.
        IF (OPTION.EQ.'EOPE') NOTIN = .FALSE.
        IF (OPTION.EQ.'SHG') NOTIN = .FALSE.
        IF (OPTION.EQ.'OR') NOTIN = .FALSE.
        IF (OPTION.EQ.'CM') NOTIN = .FALSE.
        IF (OPTION.EQ.'EV') NOTIN = .FALSE.
        IF (OPTION.EQ.'NM') NOTIN = .FALSE.
        IF (OPTION.EQ.'AU') NOTIN = .FALSE.
C
C     *** Check hidden population options ***
C
      ELSE IF (KEYWORD.EQ.'POPULATION') THEN
C
        IF (OPTION(1:5).EQ.'FRACT') NOTIN = .FALSE.
        IF (OPTION(1:5).EQ.'ITERA') NOTIN = .FALSE.
        IF (OPTION(1:3).EQ.'SCF') NOTIN = .FALSE.
C
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of LOGICAL FUNCTION NOTIN ***
C
      END
