      SUBROUTINE PCGINI(OPTION)
C
C     Purpose: Initialize pre-conditioned conjugated gradient iteration.
C
C     History: - Creation (19.09.07, AMK)
C
C     ******************************************************************
C
      IMPLICIT NONE
C
CCC ADLL
      INCLUDE 'parameter.h'
C
CCC ADLL
      INCLUDE 'flags.h'
      INCLUDE 'iteration.h'
      INCLUDE 'pcg.h'
      INCLUDE 'tolerance.h'
CCC ADLL
      INCLUDE 'rtdft.h'
CCC ADLL
C
      CHARACTER*(*) OPTION
C
C     ------------------------------------------------------------------
C
C     *** Initialize counter and flags ***
C
      PCGCYC = 0
      CONVERGED = .FALSE.
C
C     *** Initialize PCG thresholds ***
C
      PCGSIX = 1.0E-7
      IF (STATUS.EQ.'ATOM GUESS') THEN
        PCGTOL = 1.0E-6
      ELSE IF (OPTION.EQ.'NUMCDC') THEN
CCC ADLL 
        IF (STATUS.EQ.'RTDFT') THEN
          PCGTOL = RTETOL/1.0E+2
        ELSE
          PCGTOL = SCFTOL/1.0E+2
        END IF
CCC ADLL
      ELSE IF (OPTION.EQ.'NUMCXC') THEN
CCC ADLL
        IF (STATUS.EQ.'RTDFT') THEN
          PCGTOL = RTETOL/1.0E+1
        ELSE
          PCGTOL = SCFTOL/1.0E+1
        END IF
CCC ADLL
      END IF
C
C     *** Initialize PCG round offs ***
C
      PCGRND = 10.0/SVDTOL**2
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE PCGINI ***
C
      END
