      SUBROUTINE PLOTTING
C
C     Purpose: Set plotting specific variables.
C
C     History: - Creation (31.01.03, AMK)
C                         (14.06.13, BZG)
C
C     ******************************************************************
C
C     List of local variables:
C
C     NPLOTFUN: Number of plot functions.
C     PLOTDER : Plot function derivative.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'plot.h'
C
C     ------------------------------------------------------------------
C
C     *** Return, if no plot function is requested ***
C
      IF (PLOTTYP.EQ.'OFF') RETURN
C
C     *** Adjust implicit plot function number ***
C
      IF ((PLOTFNC.EQ.'PSI').OR.(PLOTFNC.EQ.'D1PSI')) THEN
        IF (PLOTMOA.EQ.'LISTED') THEN
          NPLOTFUN = PLOTMOSA(0)
          IF (OKS) NPLOTFUN = NPLOTFUN + PLOTMOSB(0)
        ELSE IF (PLOTMOA.EQ.'HLGAP') THEN
          NPLOTFUN = 2
          IF (OKS) NPLOTFUN = 4
        ELSE IF (PLOTMOA.EQ.'HOMO') THEN
          NPLOTFUN = 1
        ELSE IF (PLOTMOA.EQ.'OUGAP') THEN
          NPLOTFUN = 0
        END IF
CCC ADLL
        IF (RTDFT) NPLOTFUN = 2*NPLOTFUN
CCC ADLL
      ELSE IF (PLOTFNC.EQ.'SGGA') THEN
        NPLOTFUN = 2
        IF (OKS) NPLOTFUN = 2*NPLOTFUN
      ELSE IF (PLOTFNC.EQ.'ELF') THEN
        NPLOTFUN = 1
        IF (OKS) NPLOTFUN = 2*NPLOTFUN
      ELSE IF (PLOTFNC.EQ.'FUKUI') THEN
        NPLOTFUN = 4
      ELSE IF (PLOTFNC.EQ.'PRHO') THEN
        NPLOTFUN = 4
      ELSE IF (PLOTFNC.EQ.'LAP') THEN
        NPLOTFUN = 2
      ELSE IF (PLOTFNC.EQ.'IMF') THEN
        NPLOTFUN = 5
      ELSE IF ((PLOTFNC.EQ.'ESP').AND.EMBED) THEN
        NPLOTFUN = 2
CCC ADLL 
      ELSE IF (PLOTFNC.EQ.'DIVJ') THEN
        NPLOTFUN = 1
      ELSE IF (PLOTFNC.EQ.'DENJ') THEN
        NPLOTFUN = 4
CCC ADLL
      ELSE
        NPLOTFUN = 1
      END IF
C
C     *** Adjust plot function number w.r.t. derivative order ***
C
      NPLOTFUN = NPLOTFUN*((PLOTDER+1)*(PLOTDER+2)*(PLOTDER+3)/6)
C
C     *** Check plot function specification ***
C
      CALL CHKPLOT('FUNCTION')
C
C     *** Check isosurface function specification ***
C
      IF (PLOTTYP.EQ.'ISOSURFACE') CALL CHKISO
C
C     *** Check molecular field for critical point search ***
C
      IF (PLOTTYP.EQ.'CPSEARCH') CALL CHKCPS
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE PLOTTING ***
C
      END
