      SUBROUTINE MULMATI(A,B,C,D,DSTO,DSTO_ME,OPTION)
C
C     Purpose: Complex matrix multiplication (A+iB)*(C+iD)
C
C     History: - Creation (29.02.16, XJ)
C
C     ******************************************************************
C     
C     List of local variables: 
C     
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'molecule.h'
      INCLUDE 'mp_demon.h'
C
      INTEGER DSTO,DSTO_ME
      REAL A(MIN(DSTO,DSTO_ME),MIN(DSTO,DSTO_ME))
      REAL B(MIN(DSTO,DSTO_ME),MIN(DSTO,DSTO_ME))
      REAL C(MIN(DSTO,DSTO_ME),MIN(DSTO,DSTO_ME))
      REAL D(MIN(DSTO,DSTO_ME),MIN(DSTO,DSTO_ME))
      CHARACTER*(*) OPTION
C
      INTEGER ALLOCATION
      REAL, ALLOCATABLE :: WORK1(:,:),WORK2(:,:)

C     ------------------------------------------------------------------
C
      ALLOCATE(WORK1(MIN(DSTO,DSTO_ME),MIN(DSTO,DSTO_ME)),
     $         WORK2(MIN(DSTO,DSTO_ME),MIN(DSTO,DSTO_ME)),
     $         STAT=ALLOCATION)
      CALL MP_SUM(ALLOCATION,ALLOCATION,1,MP_INT)
      IF (ALLOCATION.GT.0) THEN
        CALL ERRMSG('COMPLX','ALLOCATION FAILED',1)
      END IF
C
C     *** Real part (A*C - B*D) *** 
C
      WORK1(:,:) = 0.0
      CALL MPMULMAT(A,C,WORK1,DSTO_ME,NORTH,'NORMAL')
      WORK1(:,:) = -WORK1(:,:)
      CALL MPMULMAT(B,D,WORK1,DSTO_ME,NORTH,'NORMALADD')
      WORK1(:,:) = -WORK1(:,:)
C
C     *** Imaginary part (A*D + B*C) ***
C
      WORK2(:,:) = 0.0
      CALL MPMULMAT(A,D,WORK2,DSTO_ME,NORTH,'NORMAL')
      CALL MPMULMAT(B,C,WORK2,DSTO_ME,NORTH,'NORMALADD')
C
C     *** Replace options  ***
C
      IF (OPTION.EQ.'REPLACEA') THEN
        A(:,:) = WORK1(:,:)
        B(:,:) = WORK2(:,:) 
      ELSE IF (OPTION.EQ.'REPLACEB') THEN
        C(:,:) = WORK1(:,:)
        D(:,:) = WORK2(:,:)
      END IF
C
C     *** Deallocate dynamical arrays ***
C
      DEALLOCATE(WORK1,WORK2,STAT=ALLOCATION)
      CALL MP_SUM(ALLOCATION,ALLOCATION,1,MP_INT)
      IF (ALLOCATION.GT.0) THEN
        CALL ERRMSG('COMPLX','DEALLOCATION FAILED',1)
      END IF
C
C     *** End of SUBROUTINE MULMATI ***
c
        END
