      SUBROUTINE PSIZ(CAR,CBR,CAI,CBI,STO,DSTO,FUNVEC,NGPB)
C
C     Purpose: Calculate molecular orbitals.
C
C     History: - Creation (22.01.97, ML)
C
C     ******************************************************************
C
C     List of local variables:
C
C     CA    : Alpha MO coefficient matrix.
C     CB    : Beta MO coefficient matrix.
C     FUNVEC: Vector with plot function values.
C     NGPB  : Number of grid points in current batch.
C     STO   : Function values of the basis functions.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE 
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'grid.h'
      INCLUDE 'plot.h'
      INCLUDE 'pointer.h'
C
      INTEGER DSTO
      REAL CAR(DSTO,DSTO),CBR(DSTO,DSTO),STO(MAXGPB,DSTO)
      REAL CAI(DSTO,DSTO),CBI(DSTO,DSTO)
C
      REAL FUNVEC(MAXGPB,MAXPLOT)
C
      INTEGER IATOM,IFUN,IGP,IMO,INEIGH,ISTO,MO,NGPB
C
C     ------------------------------------------------------------------
C
C     *** Calculate alpha MO functions ***
C
      DO IMO=1,PLOTMOSA(0)
        MO = PLOTMOSA(IMO)
        IFUN =  2*(IMO-1) + 1
        DO IGP=1,NGPB
          FUNVEC(IGP,IFUN) = 0.0
          FUNVEC(IGP,IFUN+1) = 0.0
          DO INEIGH=1,NNEIGH
            IATOM = NEIGH(INEIGH)
            DO ISTO=LL(IATOM),UL(IATOM)
              FUNVEC(IGP,IFUN) = FUNVEC(IGP,IFUN) + 
     $                          STO(IGP,ISTO)*CAR(ISTO,MO)
              FUNVEC(IGP,IFUN+1) = FUNVEC(IGP,IFUN+1) +
     $                          STO(IGP,ISTO)*CAI(ISTO,MO)
            END DO
          END DO
        END DO
      END DO
C
C     *** Calculate beta MO functions ***
C
      DO IMO=1,PLOTMOSB(0)
        MO = PLOTMOSB(IMO)
        IFUN = 2*(IMO-1) +  2*PLOTMOSA(0)
        DO IGP=1,NGPB
          FUNVEC(IGP,IFUN) = 0.0
          FUNVEC(IGP,IFUN+1) = 0.0
          DO INEIGH=1,NNEIGH
            IATOM = NEIGH(INEIGH)
            DO ISTO=LL(IATOM),UL(IATOM)
              FUNVEC(IGP,IFUN) = FUNVEC(IGP,IFUN) + 
     $                           STO(IGP,ISTO)*CBR(ISTO,MO)
              FUNVEC(IGP,IFUN+1) = FUNVEC(IGP,IFUN+1) +
     $                          STO(IGP,ISTO)*CBI(ISTO,MO)
            END DO
          END DO
        END DO
      END DO
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE PSIZ ***
C
      END
