      SUBROUTINE BLDBBT(CONVEC,IATOM)
C
C     Purpose: Build MM atomic bond, bend and torsion connectivity.
CTODO
CTODO Only for compatibility
CTODO
C
C     History: - Creation (07.04.14, GG)
C                         (27.01.17, TM)
C
C     ******************************************************************
C
C     List of local variables:
C
C     CONVEC: Contain connection for atom IATOM.
C     IATOM : Atom number to build connections for.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
C
      INTEGER CONVEC(NATMM)
C
      LOGICAL LINKED
      INTEGER IATOM,ILINK,JATOM
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
      CONVEC(:) = 0
C
C     *** Quick return for isolated atom or ion ***
C
      IF ((LINKMM(IATOM+NATOM,0).EQ.1).AND.
     $    (LINKMM(IATOM+NATOM,1).EQ.0)) RETURN
C
C     *** Build input based connectivity vector ***
C
      IF (LINKMM(IATOM+NATOM,0).NE.0) THEN
C
        DO ILINK=1,LINKMM(IATOM+NATOM,0)
          JATOM = LINKMM(IATOM+NATOM,ILINK) - NATOM
CCC ADLL LA
          IF (JATOM.GT.0) CONVEC(JATOM) = 1
CCC ADLL LA
        END DO
C
C     *** Build distance based connectivity vector ***
C
      ELSE
C
        DO JATOM=1,NATMM
          IF (LINKED(NATOM+IATOM,NATOM+JATOM)) CONVEC(JATOM) = 1
        END DO
C
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE BLDBBT *** 
C
      END
