      SUBROUTINE BLDLNK(LNKVEC,IATOM,NDANG)
C
C     Purpose: Build atomic link vector.
C
C     History: - Creation (02.06.14, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     IATOM : Atom for which link vector is build.
C     LNKVEC: Atomic link vector.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
C
      INTEGER LNKVEC(NATOM_ALL)
C
CCC ADLL
      INTEGER NDANG
CCC ADLL
      LOGICAL LINKED
      INTEGER IATOM,ILINK,JATOM
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
CCC ADLL QMMM
      NDANG = 0
CCC ADLL QMMM
      LNKVEC(:) = 0
C
C     *** Build input based atomic link vector ***
C
      IF (LINKMM(IATOM,0).NE.0) THEN
C
        DO ILINK=1,LINKMM(IATOM,0)
          JATOM = LINKMM(IATOM,ILINK)
CCC ADLL
          IF (JATOM.GT.0) THEN
            LNKVEC(JATOM) = 1
          ELSE IF (JATOM.EQ.0) THEN
            NDANG = NDANG + 1
          END IF
C          LNKVEC(JATOM) = 1
CCC ADLL
        END DO
C
C     *** Build distance based atomic link vector ***
C
      ELSE
C
        DO JATOM=1,NATOM_ALL
          IF (LINKED(IATOM,JATOM)) LNKVEC(JATOM) = 1
        END DO
C
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE BLDLNK *** 
C
      END
