      SUBROUTINE CHKCART
C
C     Purpose: Check Cartesian input.
C
C     History: - Creation (13.06.02, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     LINE: Input line.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'fileio.h'
      INCLUDE 'flags.h'
      INCLUDE 'molecule.h'
C
      LOGICAL ASSIGNED,BLOCKEND,ERROR
      CHARACTER*80 DTS,LINE,LTU,PRTSTR,STRCOMP,STRING,STRTYP*7
      INTEGER IATOM,IVALUE,ITOKEN,NTOKEN,STREXT
      REAL RVALUE
C
      CHARACTER*80 TOKEN(500)
CCC ADLL QMMM
      INTEGER INF
      CHARACTER*10 ATYPE
CCC ADLL QMMM
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
      NATMM = 0
      NATOM = 0
      NDUMMY = 0
C
      ERROR = .FALSE.
CCC ADLL QMMM
      IF (FGEO) THEN
        INF = GEO
        REWIND(INF)
      ELsE
        INF = INP
      END IF
C
      IF (FGEO) THEN
        REWIND(INF)
 100    CONTINUE
        READ (INF,'(A)',ERR=99980,END=99980) LINE
        IF (INDEX(LINE,'GEOME').EQ.0) GO TO 100
      END IF
CCC ADLL QMMM

C
C     *** Read Cartesian input ***
C
      IATOM = 0
C
  500 CONTINUE
C
        ASSIGNED = .FALSE.
CCC ADLL QMMM
        READ (INF,'(A)',ERR=99980,END=1000) LINE  
        STRING = STRCOMP(LTU(DTS(LINE)))
        IF (BLOCKEND(STRING)) GO TO 1000
        IATOM = IATOM + 1
C
C     *** Tokenize input line ***
C
        CALL STRTOK(STRING,NTOKEN,TOKEN)
        IF (((INPTYP.EQ.'CARTESIAN').AND.(NTOKEN.LT.4)).OR.
     $      ((INPTYP.EQ.'MIXED').AND.(NTOKEN.LT.2))) THEN
          WRITE (PRTSTR,5000) IATOM
 5000     FORMAT ('DEFINITION OF ATOM ',I4,' IS INCOMPLETE')
          CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
          GO TO 99990
        END IF
C
C     *** Check end of Cartesian coordinates for mixed input ***
C
        IF (INPTYP.EQ.'MIXED') THEN
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,IVALUE)
          IF (STRTYP.NE.'FLOAT') THEN
CCC ADLL QMMM
            BACKSPACE (INF)
            IATOM = IATOM - 1
            GO TO 1000
          END IF
        END IF
C
C     *** Check ZATOM and MATOM entries ***
C
        DO ITOKEN=5,NTOKEN
          CALL GETNUM(TOKEN(ITOKEN),STRTYP,RVALUE,IVALUE)
          IF (STRTYP.EQ.'INTEGER') THEN
            ASSIGNED = .TRUE.
            IF (IVALUE.GT.0) NATOM = NATOM + 1
            IF (IVALUE.LT.0) NATMM = NATMM + 1
            IF (IVALUE.EQ.0) NDUMMY = NDUMMY + 1
            EXIT
          ELSE IF (STRTYP.EQ.'STRING') THEN
            WRITE (PRTSTR,5010) ITOKEN
 5010       FORMAT ('ERROR IN POSITION ',I2,'; NO STRING EXPECTED')
            CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
            GO TO 99990
          END IF
        END DO
C
C     *** Set and check number of atoms ***
C
        IF (.NOT.ASSIGNED) NATOM = NATOM + 1
        CALL MAXCHK('ATOMS')
C
C     *** Check atomic label ***
C
        IF (STREXT(TOKEN(1)).GT.MAXLAB) THEN
          WRITE (PRTSTR,5020) TOKEN(1)(1:STREXT(TOKEN(1)))
 5020     FORMAT ('LABEL < ',A,' > TOO LONG (MAX. 10 CHRS.)')
          CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
          GO TO 99990
        END IF
C
        CALL CHKLABEL(TOKEN(1),ATOMNO(IATOM),ERROR)
        IF (ERROR) GO TO 99990
        ATOMLAB(IATOM) = TOKEN(1)
C
      GO TO 500
C
 1000 CONTINUE
C
C     *** Set number of atoms ***
C
      NATXYZ(1) = IATOM
C
      RETURN
C
C     ------------------------------------------------------------------
C
C     *** Handling of read errors ***
C
99980 CONTINUE
      WRITE (PRTSTR,99985) IATOM+1
99985 FORMAT ('ERROR IN CARTESIAN COORDINATE LINE ',I4)
      CALL MESSAGE(0,'--> '//TRIM(LINE),1,0)
      CALL ERRMSG('CHKCART',STRCOMP(PRTSTR),1)
C
99990 CONTINUE
      WRITE (PRTSTR,99995) IATOM
99995 FORMAT ('ERROR IN CARTESIAN COORDINATE LINE ',I4)
      CALL MESSAGE(0,'--> '//TRIM(LINE),1,0)
      CALL ERRMSG('CHKCART',STRCOMP(PRTSTR),1)
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE CHKCART ***
C
      END
