      SUBROUTINE CHKLABEL(TOKEN,NUMBER,ERROR)
C
C     Purpose: Check token for atomic symbol and return atomic number.
C
C     History: - Creation (23.04.97, BZ)
C                         (14.02.08, AMK)
C
C     ******************************************************************
C
C     List of local variables:
C
C     NUMBER: Atomic number.
C     TOKEN : Token to check.
C     
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'strings.h'
C
      LOGICAL ERROR
      CHARACTER*2 LABEL,SYMBOL
      CHARACTER*80 LTU,PRTSTR,STRCOMP
      INTEGER IPOS,NUMBER,STREXT
C
      CHARACTER*(*) TOKEN
C
C     ------------------------------------------------------------------
C
      ERROR = .FALSE.
C
C     *** Check for forbidden label ***
C
      READ (TOKEN,'(A2)') LABEL
C
      IF (STATUS.EQ.'READ IN') THEN
        IF (INDEX(LABEL,FORBIDS).NE.0) THEN
          PRTSTR = 'ELEMENT LABEL: '//FORBIDS//' IS NOT ALLOWED'
          CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
          ERROR = .TRUE.
          RETURN
        END IF
CCC ADLL LA
        IF (INDEX(LABEL,'XL').NE.0) THEN
          PRTSTR = 'ELEMENT LABEL: '//FORBIDS//' IS NOT ALLOWED'
          CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
          ERROR = .TRUE.
          RETURN
        END IF
CCC ADLL LA
      END IF
C
C     *** Check for AA labels ***
C
      READ (TOKEN,'(A2)') LABEL
C
      DO IPOS=0,111
        PRTSTR = LTU(ELSYM(IPOS))
        SYMBOL = PRTSTR(:2)
        IF (INDEX(LABEL,SYMBOL).NE.0) GO TO 500
      END DO
C
C     *** Check for A labels ***
C
      READ (TOKEN,'(A1)') LABEL
C
      DO IPOS=0,111
        SYMBOL(1:1) = ELSYM(IPOS)(2:2)
        IF (INDEX(LABEL(1:1),SYMBOL(1:1)).NE.0) GO TO 500
      END DO
C
C     *** Error incorrect label ***
C
      WRITE (PRTSTR,'(A,A)') 'ELEMENT NOT RECOGNIZED: ',TOKEN(1:2)
      CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
      ERROR = .TRUE.
C
  500 CONTINUE
C
      NUMBER = IPOS
C
C     *** Check label length ***
C
      IF (STREXT(TOKEN).GT.MAXLAB) THEN
        WRITE (PRTSTR,5000) TOKEN(1:STREXT(TOKEN))
 5000   FORMAT ('LABEL < ',A,' > TOO LONG (MAX. 10 CHRS.)')
        CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
        ERROR = .TRUE.
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE CHKLABEL ***
C
      END
