      SUBROUTINE D1NUCREP(GRADIENT,DXYZ)
C
C     Purpose: Calculation of nuclear repulsion gradients.
C
C     History: - Creation (14.12.99, AMK)
C                         (07.10.10, AG)
C                         (13.11.14, GG)
C
C     ******************************************************************
C
C     List of local variables:
C
C     GRADIENT: SCF energy gradient vector.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'embed.h'
      INCLUDE 'flags.h'
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
C
      INTEGER DXYZ
      REAL GRADIENT(3,DXYZ)
C
      INTEGER I,IATOM,JATOM,JEMBED
      REAL D,GRADA
C
      REAL R(3)
C
C     ------------------------------------------------------------------
C
C     *** Calculation of nuclear repulsion force ***
C
      DO 30 IATOM=1,NATOM
        DO 20 JATOM=IATOM+1,NATOM
          CALL ATOMDIS(JATOM,IATOM,R,D)
          DO 10 I=1,3
            GRADA = ZATOM(IATOM)*ZATOM(JATOM)*R(I)/SQRT(D)**3
            GRADIENT(I,IATOM) = GRADIENT(I,IATOM) + GRADA
            GRADIENT(I,JATOM) = GRADIENT(I,JATOM) - GRADA
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
C     *** Add nuclear repulsion force of embedding ***
C
      IF (EMBED) THEN
        DO 60 IATOM=1,NATOM
          DO 50 JEMBED=1,NEMBED
            CALL CUBEDIS(IATOM,JEMBED,R,D)
            DO 40 I=1,3
              GRADA = ABS(ZATOM(IATOM))*QEMBED(JEMBED)*R(I)/SQRT(D)**3
              GRADIENT(I,IATOM) = GRADIENT(I,IATOM) - GRADA
   40       CONTINUE
   50     CONTINUE
   60   CONTINUE
      END IF
C
C     *** Add nuclear repulsion force of MM region ***
C
      IF (QMMM) THEN
CCC ADLL LA
C
      CALL SCLCHGMM('SCALE')
C
CCC ADLL LA
        DO 90 IATOM=1,NATOM
          DO 80 JATOM=1,NATMM
            CALL QMMMDIS(IATOM,JATOM,R,D)
            DO 70 I=1,3
              GRADA = -ZATOM(IATOM)*CHGMM(JATOM)*R(I)/SQRT(D)**3
              GRADIENT(I,IATOM) = GRADIENT(I,IATOM) + GRADA
              GRADIENT(I,NATOM+JATOM) = GRADIENT(I,NATOM+JATOM) - GRADA
   70       CONTINUE
   80     CONTINUE
   90   CONTINUE
CCC ADLL LA
C
      CALL SCLCHGMM('RESTORE')
C
CCC ADLL LA
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE D1NUCREP ***
C
      END
