      SUBROUTINE D1QMMMCHG(GRADIENT,MDEG)
C
C     Purpose: Calculation of QM nuclear -- MM charge gradients.
C
C     History: - Creation (07.08.11, AG)
C                         (13.11.14, GG)
C                         (19.11.14, AMK) 
C
C     ******************************************************************
C
C     List of local variables:
C
C     GRADIENT: SCF energy gradient vector.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'flags.h'
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
C
      INTEGER MDEG
      REAL GRADIENT(3,MDEG)
C
      INTEGER I,IATOM,JATOM
      REAL D,GRADA
C
      REAL R(3)
C
C     ------------------------------------------------------------------
C
CCC ADLL LA
C     *** Scale down MM charges near link atoms ***
C
      CALL SCLCHGMM('SCALE')
C
CCC ADLL LA
C
C     *** Calculation of QM/MM point charge force ***
C
      IF (QMMM) THEN
        DO 30 IATOM=1,NATOM
          DO 20 JATOM=1,NATMM
            CALL QMMMDIS(IATOM,JATOM,R,D)
            DO 10 I=1,3
              GRADA = -ZATOM(IATOM)*CHGMM(JATOM)*R(I)/SQRT(D)**3
              GRADIENT(I,IATOM) = GRADIENT(I,IATOM) + GRADA
              GRADIENT(I,NATOM+JATOM) = GRADIENT(I,NATOM+JATOM) - GRADA
   10       CONTINUE
   20     CONTINUE
   30   CONTINUE 
      END IF
C
CCC ADLL LA
C
C     *** Restore orginal charges ***
C
      CALL SCLCHGMM('RESTORE')
C
CCC ADLL LA
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE D1QMMMCHG ***
C
      END
