      SUBROUTINE READPARAM
C
C     Purpose: Read mm parameters from the prepared file FFDS.
C
C     History: - Creation (14.11.08, AG)
C                         (13.11.14, GG)
C                         (06.12.16, TM)
C
C     ******************************************************************
C
C     List of local variables:
C
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'fileio.h'
      INCLUDE 'mm.h'
      INCLUDE 'mmpot.h'
      INCLUDE 'prm.h'
CCC ADLL LA
      INCLUDE 'qmmm.h'
CCC ADLL LA
C
      CHARACTER*100 DTS,EXTENS1,EXTENS2,EXTENS3,LINE,LTU,PRTSTR,
     $              STRCOMP,STRING,STRTYP*7
      CHARACTER*80 TOKEN(80)
      INTEGER I,ICLASS,II,IJ,IK,IL,ITYPE,IVALUE,I1,I2,I3,I4,
     $        J,JJ,JLIM,JP,JTYPE,J1,J2,K,KK,KLINE,L,LAST,LL,NCLASSLNK,
     $        NTOKEN,TYP
      INTEGER CLASSLNK(MAXTYPE,2),FOLD(4)
CCC ADLL LA
      INTEGER CLASSLA(MAXTYPE,2),NCLASSLA
      REAL BR
CCC ADLL LA
      REAL BB,FK,QQ,RVALUE
      REAL BA(4),GAM(4),VT(4)
      LOGICAL NEWCLASS
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
      NCLASS = 0
      ICLASS = 0
      NBND = 0
      NANG = 0
      NTANG = 0
      NUREY = 0
      NIMTORS = 0
      BB = 0
      BA(:) = 0
      NCHARGE = 0
CCC ADLL LA
      NALTM = 0
CCC ADLL LA
      CHG(:) = 0
      CLASSOFTYP1(:) = 0
      CLASS1(:) = 0
      ZTYP(:) = 0
      NNEIGHMM(:) = 0
C
C     *** Read the atom parameters for the needed types ***
C
      DO 10 ITYPE=1,NTYPES
C
        REWIND (IOFFD)
C
C     *** Go to the ATOM keyword lines ***
C
        DO J=1,KEYWLINES
          READ (IOFFD,'(A80)',ERR=99990) LINE
        END DO
C
        KLINE = KEYWLINES
        DO  20 I=1,ATOMLINES
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
C
          CALL CUT(STRING,1,LAST)
          EXTENS1 = STRING(1:LAST)
          EXTENS2 = STRING(LAST+2:)
C
          CALL CUT(EXTENS2,1,LAST)
          EXTENS3 = EXTENS2(LAST+2:)
          EXTENS2 = EXTENS2(1:LAST)
C
          STRING = EXTENS1
          CALL STRTOK(STRING,NTOKEN,TOKEN)
C
C     *** Read Atom type of FF atoms ***
C
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,TYP)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM ATOM TYPE MUST BE INTEGER',1,0)
            GO TO 99990
          ELSE IF (TYP.GT.MAXTYPE) THEN
            CALL MESSAGE(1,'NUMBER OF TYPES MUST BE < MAXTYPE',1,0)
            GO TO 99990
          END IF
C
C     *** Check if TYP fits with a TYPEMM value
C
          IF (TYP.NE.TYPES(ITYPE)) CYCLE
C
C     *** Read Atom Class of FF atoms ***
C
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,CLASSOFTYP1(TYP))
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'ATOM CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          ELSE IF (CLASSOFTYP1(TYP).GT.MAXCLASS) THEN
            CALL MESSAGE(1,'CLASS NUMBER MUST BE < MAXCLASS',1,0)
            GO TO 99990
          END IF
C
C     *** Read Atom Number and Mass of FF atoms ***
C
          STRING = STRCOMP(LTU(DTS(EXTENS3)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(1),STRTYP,RVALUE,ZTYP(TYP))
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'TYPE ZVALUE MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(2),STRTYP,MASSTYP(TYP),IVALUE)
          IF (STRTYP.EQ.'INTEGER') THEN
            CALL MESSAGE(1,'MASS TYPE MUST BE REAL',1,0)
            GO TO 99990
          END IF
C
C     *** Read Number of Atoms linked to Atom Type ***
C
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,NNEIGHMM(TYP))
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'NUMBER OF NEIGHBOURS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
C
   20   CONTINUE
C
   10 CONTINUE
C
C     *** Determine the number of classes in the system ***
C
      CLASS1(1) = CLASSOFTYP1(TYPES(1))
      NCLASS = 1
      DO ITYPE=2,NTYPES
        NEWCLASS = .TRUE.
        DO JTYPE=1,ITYPE-1
          IF (CLASSOFTYP1(TYPES(ITYPE)).EQ.
     $        CLASSOFTYP1(TYPES(JTYPE))) THEN
            NEWCLASS = .FALSE.
            EXIT
          END IF
        END DO
        IF (NEWCLASS) THEN
          NCLASS = NCLASS + 1
          CLASS1(NCLASS) = CLASSOFTYP1(TYPES(ITYPE))
        END IF
      END DO
C
C     *** Other keywords are read using the previous parameters ***
C
      KLINE = KEYWLINES + ATOMLINES
C
      IF (VDWLINES.NE.0) THEN
C
        DO 30 I=1,VDWLINES
C
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,II)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM VDW CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
C
C     *** Read vdW parameter by TYPE ***
C
          IF (VDWINDX.EQ.'TYPE') THEN
C
            DO ITYPE=1,NTYPES
              IF (II.EQ.TYPES(ITYPE)) THEN
                IF (TOKEN(1)(1:4).EQ.'VDW ') THEN
                  CALL GETNUM(TOKEN(3),STRTYP,VRAD(ITYPE),IVALUE)
                  IF (STRTYP.EQ.'INTEGER') THEN
                    CALL MESSAGE(1,'VDWRAD MUST BE REAL',1,0)
                    GO TO 99990
                  END IF
                  CALL GETNUM(TOKEN(4),STRTYP,VEPS(ITYPE),IVALUE)
                  IF (STRTYP.EQ.'INTEGER') THEN
                    CALL MESSAGE(1,'VDW EN. MUST BE REAL',1,0)
                    GO TO 99990
                  END IF
                  IF (NTOKEN.GT.4) THEN
                    CALL GETNUM(TOKEN(5),STRTYP,REDUC(ITYPE),IVALUE)
                    IF (STRTYP.EQ.'INTEGER') THEN
                      CALL MESSAGE(1,'VDW FACTOR. MUST BE REAL',1,0)
                      GO TO 99990
                    END IF
                  END IF
                  DOVDW = .TRUE.
                END IF
              END IF
            END DO
C
C     *** Read vdW parameter by CLASS ***
C
          ELSE IF (VDWINDX.EQ.'CLASS') THEN
C
            DO ICLASS=1,NCLASS
              IF (II.EQ.CLASS1(ICLASS)) THEN
                IF (TOKEN(1)(1:4).EQ.'VDW ') THEN
                  CALL GETNUM(TOKEN(3),STRTYP,VRAD(ICLASS),IVALUE)
                  IF (STRTYP.EQ.'INTEGER') THEN
                    CALL MESSAGE(1,'VDWRAD MUST BE REAL',1,0)
                    GO TO 99990
                  END IF
                  CALL GETNUM(TOKEN(4),STRTYP,VEPS(ICLASS),IVALUE)
                  IF (STRTYP.EQ.'INTEGER') THEN
                    CALL MESSAGE(1,'VDW EN. MUST BE REAL',1,0)
                    GO TO 99990
                  END IF
                  IF (NTOKEN.GT.4) THEN
                    CALL GETNUM(TOKEN(5),STRTYP,REDUC(ICLASS),IVALUE)
                    IF (STRTYP.EQ.'INTEGER') THEN
                      CALL MESSAGE(1,'VDW FACTOR. MUST BE REAL',1,0)
                      GO TO 99990
                    END IF
                  END IF
                  DOVDW = .TRUE.
                END IF
              END IF
            END DO
C
C     *** Error handling ***
C
          ELSE
C
            CALL ERRMSG('READPARAM','UNKNOWN VDW-INDEXING OPTION: '//
     $                  TRIM(VDWINDX),1)
C
          END IF
C
   30   CONTINUE
C
      END IF 
C
       NCLASSLNK = 1
       CLASSLNK(1,1) = CLASSOFTYP1(TYPLNK(1,1))
       CLASSLNK(1,2) = CLASSOFTYP1(TYPLNK(1,2))
C
       DO I=2,NTYPLNK
         J1 = TYPLNK(I,1)
         J2 = TYPLNK(I,2)
         II = CLASSOFTYP1(J1)
         JJ = CLASSOFTYP1(J2)
         K = 1
         DO L=1,I-1
           IF ((CLASSOFTYP1(TYPLNK(L,1)).EQ.II.AND.
     $          CLASSOFTYP1(TYPLNK(L,2)). EQ.JJ).OR.
     $         (CLASSOFTYP1(TYPLNK(L,2)).EQ.II.AND.
     $          CLASSOFTYP1(TYPLNK(L,1)). EQ.JJ)) K = 0
         END DO
         IF (K.NE.0) THEN
           NCLASSLNK = NCLASSLNK + 1
           CLASSLNK(NCLASSLNK,1) = II
           CLASSLNK(NCLASSLNK,2) = JJ
         END IF
       END DO
CCC ADLL LA
       DO I=1,NTYPLA
         J1 = TYPLA(I,1)
         J2 = TYPLA(I,2)
         II = CLASSOFTYP1(J1)
         JJ = CLASSOFTYP1(J2)
         K = 1
         DO L=1,I-1
           IF ((CLASSOFTYP1(TYPLA(L,1)).EQ.II.AND.
     $          CLASSOFTYP1(TYPLA(L,2)). EQ.JJ).OR.
     $         (CLASSOFTYP1(TYPLA(L,2)).EQ.II.AND.
     $          CLASSOFTYP1(TYPLA(L,1)). EQ.JJ)) K = 0
         END DO
         IF (K.NE.0) THEN
           NCLASSLNK = NCLASSLNK + 1
           CLASSLNK(NCLASSLNK,1) = II
           CLASSLNK(NCLASSLNK,2) = JJ
         END IF
       END DO
CCC ADLL LA

C
      KLINE = KLINE + VDWLINES
C
      IF (BONDLINES.NE.0) THEN
        DO 40 I=1,BONDLINES
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,I1)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM BOND CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,I2)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM BOND CLASS MUST BE INTEGER',1,0)
            GO TO 99990 
          END IF
          CALL GETNUM(TOKEN(4),STRTYP,FK,IVALUE)
          IF (STRTYP.NE.'FLOAT') THEN
            CALL MESSAGE(1,'MM FORCE CST MUST BE REAL',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(5),STRTYP,BB,IVALUE)
          IF (STRTYP.NE.'FLOAT') THEN
            CALL MESSAGE(1,'MM BOND EQ. LENGTH MUST BE REAL',1,0)
            GO TO 99990
          END IF
C
C     *** Check if the line fits with Class values
C
          DO J=1,NCLASSLNK
            II = CLASSLNK(J,1)
            IJ = CLASSLNK(J,2)
            IF ((II.EQ.I1).AND.(IJ.EQ.I2)) THEN
              NBND = NBND + 1
              MMBOND(NBND,1) = I1
              MMBOND(NBND,2) = I2
              KBND(NBND) = FK
              BND0(NBND) = BB
            ELSE IF (II.EQ.I2.AND.IJ.EQ.I1) THEN
              NBND = NBND + 1
              MMBOND(NBND,1) = I1
              MMBOND(NBND,2) = I2
              KBND(NBND) = FK
              BND0(NBND) = BB
            END IF
          END DO
   40   CONTINUE
      END IF
C
      IF (NBND.GT.0)  DOBOND = .TRUE.
      KLINE = KLINE + BONDLINES
CCC ADLL LA
C
       NCLASSLA = 1
       CLASSLA(1,1) = CLASSOFTYP2(TYPLA(1,1))
       CLASSLA(1,2) = CLASSOFTYP1(TYPLA(1,2))
C
       DO I=2,NTYPLA
         J1 = TYPLA(I,1)
         J2 = TYPLA(I,2)
         II = CLASSOFTYP2(J1)
         JJ = CLASSOFTYP1(J2)
         K = 1
         DO L=1,I-1
           IF ((CLASSOFTYP2(TYPLA(L,1)).EQ.II.AND.
     $          CLASSOFTYP1(TYPLA(L,2)). EQ.JJ).OR.
     $         (CLASSOFTYP1(TYPLA(L,2)).EQ.II.AND.
     $          CLASSOFTYP2(TYPLA(L,1)). EQ.JJ)) K = 0
         END DO
         IF (K.NE.0) THEN
           NCLASSLA = NCLASSLA + 1
           CLASSLA(NCLASSLA,1) = II
           CLASSLA(NCLASSLA,2) = JJ
         END IF
       END DO
      IF (LINKATLINES.NE.0) THEN
C
        DO 75 I=1,LINKATLINES
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,I1)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'LINK ATOM CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,I2)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'LINK ATOM CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          BR = 0.72
          CALL GETNUM(TOKEN(4),STRTYP,BR,IVALUE)
          IF (STRTYP.NE.'FLOAT') THEN
            CALL MESSAGE(1,'LINK ATOM LENGTH RATIO MUST BE REAL',1,0)
            GO TO 99990
          END IF
          BB = 0.0
          IF (NTOKEN.GT.4) THEN
            CALL GETNUM(TOKEN(5),STRTYP,RVALUE,IVALUE)
            IF (STRTYP.EQ.'FLOAT') THEN
              BB = RVALUE
            ELSE
              GO TO 99990
            END IF
          END IF
C
          DO J=1,NCLASSLA
            II = CLASSLA(J,1)
            IJ = CLASSLA(J,2)
            IF ((II.EQ.I1).AND.(IJ.EQ.I2)) THEN
              NALTM = NALTM + 1
              LABOND(NALTM,1) = I1
              LABOND(NALTM,2) = I2
              LACR(NALTM) = BR
              LACAP(NALTM) = BB
            END IF
          END DO

  75    CONTINUE
      END IF
C
      KLINE = KLINE + LINKATLINES
CCC ADLL LA

C
      IF (ANGLELINES.NE.0) THEN
C
        DO 50 I=1,ANGLELINES
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,I1)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM ANGLE CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,I2)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM ANGLE CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(4),STRTYP,RVALUE,I3)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM ANGLE CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(5),STRTYP,FK,IVALUE)
          IF (STRTYP.NE.'FLOAT') THEN
            CALL MESSAGE(1,'MM ANGLE FORCE CST MUST BE REAL',1,0)
            GO TO 99990
          END IF
          K = 5
          DO J=1,NTOKEN-5
            CALL GETNUM(TOKEN(K+J),STRTYP,BA(J),IVALUE)
            IF (STRTYP.NE.'FLOAT') THEN
              CALL MESSAGE(1,'MM BOND ANGLE EQ. MUST BE REAL',1,0)
              GO TO 99990
            END IF
          END DO
C
C     *** Check if the line fits with Class values
C
          DO J = 1,NCLASS
            II = CLASS1(J)
            IF (I2.EQ.II)THEN
              DO K=1,NCLASS
                IK = CLASS1(K)
                DO L=1,NCLASS
                  IL = CLASS1(L)
                  IF (IK.EQ.I1.AND.IL.EQ.I3) THEN
                    NANG = NANG + 1
                    MMBANG(NANG,1) = I1
                    MMBANG(NANG,2) = I2
                    MMBANG(NANG,3) = I3
                    KBANG(NANG) = FK
                    BANG0(NANG,1) = BA(1)
                    BANG0(NANG,2) = BA(2)
                    BANG0(NANG,3) = BA(3)
                  ELSE IF (IK.EQ.I3.AND.IL.EQ.I1) THEN
                    NANG = NANG + 1
                    MMBANG(NANG,1) = I1
                    MMBANG(NANG,2) = I2
                    MMBANG(NANG,3) = I3
                    KBANG(NANG) = FK
                    BANG0(NANG,1) = BA(1)
                    BANG0(NANG,2) = BA(2)
                    BANG0(NANG,3) = BA(3)
                  END IF
                END DO
              END DO
            END IF
          END DO
   50   CONTINUE
      END IF
C
      DO I=1,NANG
        IF (BANG0(I,2).EQ.0.0.AND.BANG0(I,3).EQ.0.0) THEN
          BANG0(I,2) = BANG0(I,1)
          BANG0(I,3) = BANG0(I,1)
        END IF
      END DO
C
      IF (NANG.GT.0) DOBANG = .TRUE.
      KLINE = KLINE + ANGLELINES
C
      IF (UREYLINES.NE.0) THEN
C
        DO 70 I=1,UREYLINES
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,I1)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM UREY CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,I2)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM UREY CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(4),STRTYP,RVALUE,I3)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM UREY CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(5),STRTYP,FK,IVALUE)
          IF (STRTYP.NE.'FLOAT') THEN
            CALL MESSAGE(1,'MM UREY FORCE CST MUST BE REAL',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(6),STRTYP,BB,IVALUE)
          IF (STRTYP.NE.'FLOAT') THEN
            CALL MESSAGE(1,'MM UREY FORCE CST MUST BE REAL',1,0)
            GO TO 99990
          END IF
C
C     *** Check if the line fits with Class values ***
C
          DO J=1,NCLASS
            JJ = CLASS1(J)
            IF (JJ.EQ.I1) THEN
              DO K=1,NCLASS
                KK = CLASS1(K)
                IF (KK.EQ.I2) THEN
                  DO L=1,NCLASS
                    LL = CLASS1(L)
                    IF (LL.EQ.I3) THEN
                      NUREY = NUREY + 1
                      MMUREY(NUREY,1) = I1
                      MMUREY(NUREY,2) = I2
                      MMUREY(NUREY,3) = I3
                      KUREY(NUREY) = FK
                      UREY0(NUREY) = BB
                    END IF
                  END DO
                END IF
              END DO
            END IF
          END DO
   70   CONTINUE
      END IF
C
      IF (NUREY.GT.0) DOUREY = .TRUE.
      KLINE = KLINE + UREYLINES
C
      IF (IMPTORLINES.GT.0) THEN
        DO 90 I=1,IMPTORLINES
          VT(:) = 0.0
          GAM(:) = 0.0
          FOLD(:) = 0
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,I1)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM IMP TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,I2)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM IMP TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(4),STRTYP,RVALUE,I3)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM IMP TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(5),STRTYP,RVALUE,I4)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM IMP TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          JLIM = NTOKEN - 5
C
          K = JLIM/3
          IF (JLIM.GT.12) THEN
            CALL MESSAGE(1,
     $                   'IMP TORSION 4-FOLD IS EXCEEDED PROGRAM STOPS',
     $                   1,0)
            GO TO 99990
          END IF
          JJ = 1
          DO J=1,K
            CALL GETNUM(TOKEN(5+JJ),STRTYP,VT(J),IVALUE)
            IF (STRTYP.NE.'FLOAT') THEN
              CALL MESSAGE(1,'IMP TORSION BARRIER MUST BE REAL',1,0)
              GO TO 99990
            END IF
            CALL GETNUM(TOKEN(5+JJ+1),STRTYP,GAM(J),IVALUE)
            IF (STRTYP.NE.'FLOAT') THEN
              CALL MESSAGE(1,'IMP TORSION OFFSET MUST BE REAL',1,0)
              GO TO 99990
            END IF
            CALL GETNUM(TOKEN(5+JJ+2),STRTYP,RVALUE,FOLD(J))
            IF (STRTYP.NE.'INTEGER') THEN
              CALL MESSAGE(1,'IMP TORSION FOLD MUST BE INTEGER',1,0)
              GO TO 99990
            END IF
            JJ = JJ + 3
          END DO
          CALL TFOLD(VT,GAM,FOLD)
C
C     *** Check if the line fits with Class values
C
          DO J=1,NCLASSLNK
            IJ = CLASSLNK(J,1)
            IK = CLASSLNK(J,2)
      
            IF (((IJ.EQ.I2).AND.(IK.EQ.I3)).OR.((IJ.EQ.I3).AND.
     $           (IK.EQ.I2))) THEN
              DO K=1,NCLASS
                II = CLASS1(K)
                DO L=1,NCLASS
                  IL = CLASS1(L)
                  IF ((II.EQ.I1).AND.(IL.EQ.I4)) THEN
                    NIMTORS = NIMTORS + 1
                    MMIMPTANG(NIMTORS,1) = I1
                    MMIMPTANG(NIMTORS,2) = I2
                    MMIMPTANG(NIMTORS,3) = I3
                    MMIMPTANG(NIMTORS,4) = I4
                    IMPTANG1(NIMTORS,1) = VT(1)
                    IMPTANG1(NIMTORS,2) = GAM(1)
                    IMPTANG2(NIMTORS,1) = VT(2)
                    IMPTANG2(NIMTORS,2) = GAM(2)
                    IMPTANG3(NIMTORS,1) = VT(3)
                    IMPTANG3(NIMTORS,2) = GAM(3)
                  END IF
                END DO
              END DO
            END IF
          END DO
   90   CONTINUE
      END IF
C
      IF (NIMTORS.GT.0) DOIMPTORS = .TRUE.
      KLINE = KLINE + IMPTORLINES
C
      IF (TORSIONLINES.GT.0) THEN
C
        DO 100 I=1,TORSIONLINES
          VT(:) = 0.0
          GAM(:) = 0.0
          FOLD(:) = 0
C
          READ (IOFFD,'(A100)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,I1)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(3),STRTYP,RVALUE,I2)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(4),STRTYP,RVALUE,I3)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          CALL GETNUM(TOKEN(5),STRTYP,RVALUE,I4)
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'MM TORSION CLASS MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          JLIM = NTOKEN - 5
C
          K = JLIM/3
          IF (JLIM.GT.12) THEN
            CALL MESSAGE(1,'TORSION 4-FOLD IS EXCEEDED PROGRAM STOPS',
     $                   1,0)
            GO TO 99990
          END IF
          JJ = 1
          DO J=1,K
            CALL GETNUM(TOKEN(5+JJ),STRTYP,VT(J),IVALUE)
            IF (STRTYP.NE.'FLOAT') THEN
              CALL MESSAGE(1,'TORSION BARRIER MUST BE REAL',1,0)
              GO TO 99990
            END IF
            CALL GETNUM(TOKEN(5+JJ+1),STRTYP,GAM(J),IVALUE)
            IF (STRTYP.NE.'FLOAT') THEN
              CALL MESSAGE(1,'TORSION OFFSET MUST BE REAL',1,0)
              GO TO 99990
            END IF
            CALL GETNUM(TOKEN(5+JJ+2),STRTYP,RVALUE,FOLD(J))
            IF (STRTYP.NE.'INTEGER') THEN
              CALL MESSAGE(1,'TORSION FOLD MUST BE INTEGER',1,0)
              GO TO 99990
            END IF
            JJ = JJ + 3
          END DO
          CALL TFOLD(VT,GAM,FOLD)
C
C     *** Check if the line fits with Class values
C
          DO J=1,NCLASSLNK
            IJ = CLASSLNK(J,1)
            IK = CLASSLNK(J,2)
            IF (((IJ.EQ.I2).AND.(IK.EQ.I3)).OR.((IJ.EQ.I3).AND.
     $          (IK.EQ.I2))) THEN
              DO K=1,NCLASS
                II = CLASS1(K)
                DO L=1,NCLASS
                  IL = CLASS1(L)
                  IF ((II.EQ.I1).AND.(IL.EQ.I4)) THEN
                    NTANG = NTANG + 1
                    MMTANG(NTANG,1) = I1
                    MMTANG(NTANG,2) = I2
                    MMTANG(NTANG,3) = I3
                    MMTANG(NTANG,4) = I4
                    TANG1(NTANG,1) = VT(1)
                    TANG1(NTANG,2) = GAM(1)
                    TANG2(NTANG,1) = VT(2)
                    TANG2(NTANG,2) = GAM(2)
                    TANG3(NTANG,1) = VT(3)
                    TANG3(NTANG,2) = GAM(3)
                    TANG4(NTANG,1) = VT(4)
                    TANG4(NTANG,2) = GAM(4)
                  END IF
                END DO
              END DO
            END IF
          END DO
          IF (NTANG.GT.0) DOTORS = .TRUE.
  100   CONTINUE
      END IF
C
      KLINE = KLINE + TORSIONLINES
C
      IF (CHARGELINES.GT.0) THEN
        DO 140 I=1,CHARGELINES
          READ (IOFFD,'(A80)',ERR=99990) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          CALL STRTOK(STRING,NTOKEN,TOKEN)
C
          IF (TOKEN(1).EQ.'CHARGE') THEN
C
            CALL GETNUM(TOKEN(2),STRTYP,RVALUE,JP)
            CALL GETNUM(TOKEN(3),STRTYP,QQ,IVALUE)
C
C     *** Check if the line fits with a TYPEMM value ***
C
            DO ITYPE=1,NTYPES
              IF (JP.EQ.TYPES(ITYPE)) THEN
                NCHARGE = NCHARGE + 1
                MMCHG(NCHARGE) = JP
                CHG(NCHARGE) = QQ
              END IF
            END DO
C
          ELSE
            CALL MESSAGE(1,'ERROR READING CHARGE KEYWORD',1,0)
            GO TO 99990
          END IF
C
  140   CONTINUE
      END IF
C
      KLINE = KLINE + CHARGELINES
C
      IF (NCHARGE.GT.0) DOCHARGE = .TRUE.
      KLINE = KLINE + BIOTYPLINES
C
C     *** End loop ITYPE ***
C
      RETURN
C
C     ------------------------------------------------------------------
C
C     *** Handling of read errors ***
C
99990 CONTINUE
      WRITE (PRTSTR,'("ERROR IN IOFFD FILE LINE: ",I10)') KLINE+I
      CALL MESSAGE(0,'--> '//TRIM(LINE),1,0)
      CALL ERRMSG('READPARAM',STRCOMP(PRTSTR),1)
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE READPARAM ***
C
      END
