      SUBROUTINE READQMMM
C
C     Purpose: Read QM atom types according to the symbol.
C
C     History: - Creation (24.07.10, AG)
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'fileio.h'
      INCLUDE 'mm.h'
      INCLUDE 'qmmm.h'
C
      LOGICAL BLOCKEND,SUCCESS
      CHARACTER*80 DTS,LINE,LTU,PRTSTR,STRCOMP,STRING,STRTYP*7
      CHARACTER*80 TOKEN(80)
      INTEGER I,IVALUE,NTOKEN
      REAL RVALUE
C
C     ------------------------------------------------------------------
C
C     *** Initialization ***
C
      TYPEQM(:) = 0
CCC ADLL LA NEWMOD
C      QMMMFF = '    '
CCC ADLL LA NEWMOD
      NTOKEN = 0
      NTYPQM = 0
C
C     *** Read Type of QM atoms from Input file ***
C
      SUCCESS = .FALSE.
      CALL FINDKEY('QM/MM',SUCCESS)
      IF (SUCCESS) THEN
C
        DO
C
          READ (INP,'(A80)',ERR=99980,END=1000) LINE
          STRING = STRCOMP(LTU(DTS(LINE)))
          IF (BLOCKEND(STRING)) GO TO 1000
C
          NTYPQM = NTYPQM + 1
C
          CALL STRTOK(STRING,NTOKEN,TOKEN)
          LABTYPQM(NTYPQM) = TOKEN(1)
          CALL GETNUM(TOKEN(2),STRTYP,RVALUE,TYPEQM(NTYPQM))
          IF (STRTYP.NE.'INTEGER') THEN
            CALL MESSAGE(1,'QM ATOM TYPE MUST BE INTEGER',1,0)
            GO TO 99990
          END IF
          TYPEQM(NTYPQM) = ABS(TYPEQM(NTYPQM))
          IF (NTOKEN.EQ.2) THEN
CCC ADLL LA
C            QMMMFF = FFIELD
CCC ADLL LA
          ELSE IF (NTOKEN.EQ.5) THEN
            IF (TOKEN(3)(1:5).EQ.'LENNA') THEN
              QMMMFF = TOKEN(3)(1:5)
              CALL GETNUM(TOKEN(4),STRTYP,C6QM(NTYPQM),IVALUE)
              IF (STRTYP.NE.'FLOAT') THEN
                CALL MESSAGE(1,'QMMM PARAM MUST BE REAL',1,0)
                GO TO 99990
              END IF
              CALL GETNUM(TOKEN(5),STRTYP,C12QM(NTYPQM),IVALUE)
              IF (STRTYP.NE.'FLOAT') THEN
                CALL MESSAGE(1,'QMMM PARAM MUST BE REAL',1,0)
                GO TO 99990
              END IF
            END IF
          ELSE
CTODO
CTODO   Variable I not set!   
CTODO
            WRITE (PRTSTR,5010) I
 5010       FORMAT ('WRONG NUMBER OF ENTRIES IN TYPEQM LINE ',I5)
            CALL MESSAGE(1,STRCOMP(PRTSTR),1,0)
            GO TO 99990
          END IF
C
        END DO
 1000   CONTINUE
      ELSE
C
        PRTSTR = 'NO QMMMPARAMS FOUND IN THE INPUT FILE'
        CALL ERRMSG('READQMMM',PRTSTR,1)
C
      END IF
C
      RETURN
C
C     ------------------------------------------------------------------
C
C     *** Handling of read errors ***
C
99980 CONTINUE
      WRITE (PRTSTR,99985) I+1
99985 FORMAT ('ERROR IN CARTESIAN COORDINATE LINE ',I4)
      CALL MESSAGE(0,'--> '//TRIM(LINE),1,0)
      CALL ERRMSG('READQMMM',STRCOMP(PRTSTR),1)

99990 CONTINUE
      WRITE (PRTSTR,'("ERROR IN QM TYPE FILE LINE: ",I10)') NTYPQM
      CALL MESSAGE(0,'--> '//TRIM(LINE),1,0)
      CALL ERRMSG('READQMMM',STRCOMP(PRTSTR),1)
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE READQMMM ***
C
      END
