      SUBROUTINE TYPINGQM
C
C     Purpose: Assign VDW properties from the deMon.prm file
C              to every QM atom.
CTODO
CTODO No standard form yet!
CTODO
C
C     History: - Creation (28.07.10, AG)
C                         (13.11.14, GG)
C                         (06.12.16, TM)
C
C     ******************************************************************
C
C     List of local variables:
C
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
CCC ADLL LA
      INCLUDE 'fileio.h'
CCC ADLL LA
      INCLUDE 'mm.h'
      INCLUDE 'mmpot.h'
      INCLUDE 'molecule.h'
CCC ADLL LA
      INCLUDE 'prm.h'
CCC ADLL LA
      INCLUDE 'qmmm.h'
      INCLUDE 'strings.h'
C
CCC ADLL LA
      LOGICAL FOUND,PRMERR
CCC ADLL LA
      CHARACTER*10 LTU,SYMBOL
      CHARACTER*80 PRTSTR,STRCOMP
CCC ADLL LA
      INTEGER IATOM,JATOM,KATOM,LATOM
      INTEGER I,I1,I2,I3,I4,II,ITYP,J,JJ,K,KK,L,L1,LL
      REAL FACT,NOVAL,SIXTH
      CHARACTER*4 LINKATOM
      PARAMETER (NOVAL=99999.9)
CCC ADLL LA
C
      INTEGER QMATYP(MAXATOM)
C
C     ------------------------------------------------------------------
C
C     *** RETURN IF QM-MM VDW Terms are not from the FFDS File ***
C    
CCC ADLL LA LA
      IF (QMMMFF.NE.FFIELD) RETURN
CCC ADLL LA LA
C
      SIXTH = 1.0/6.0
      FACT = 2**SIXTH
      QMCLASS = 0
C
C     *** Determine the MM class for the QM atoms ***
C
      DO IATOM=1,NATOM
        FOUND = .FALSE.
        DO ITYP=1,NTYPQM
          SYMBOL = TRIM(LABTYPQM(ITYP))
          IF (SYMBOL.EQ.LTU(ATOMLAB(ATOMMAP(IATOM,1)))) THEN
            FOUND = .TRUE.
            QMCLASS(IATOM) = CLASSOFTYP2(TYPEQM(ITYP))
            QMATYP(IATOM) = TYPEQM(ITYP)
          ELSE IF (SYMBOL.EQ.ADJUSTL(LTU(ELSYM(ATOMNO(IATOM))))) THEN
            FOUND = .TRUE.
            QMCLASS(IATOM) = CLASSOFTYP2(TYPEQM(ITYP))
            QMATYP(IATOM) = TYPEQM(ITYP)
          END IF
        END DO
        IF (.NOT.FOUND) THEN
          WRITE (PRTSTR,5000) ATOMLAB(ATOMMAP(IATOM,1))
 5000     FORMAT ('NO QM/MM PARAMETERS DEFINED FOR ATOM ',A)
          CALL ERRMSG('TYPINGQM',STRCOMP(PRTSTR),1)
        END IF
      END DO
C
C     *** Determine the VDW atom sites ***
C
      NATOMVDW = 0
      ATQMVDW = 0
C
C     *** Read MM vdW parameters for QM atoms by ***
C     *** TYPE or CLASS for QM/MM calculations   ***
C
CCC ADLL LA
      LINKATOM = 'HLFL'
      DO I=1,NATOM
        IF (INDEX(LINKATOM,ATOMLAB(ATOMMAP(I,1))(1:2)).NE.0) THEN
          VLJRADQM(I) = 0.0
          VLJEPSQM(I) = 0.0 
        ELSE IF (VDWINDX.EQ.'TYPE') THEN
CCC ADLL LA
          DO J=1,NTYPQM
            IF (QMATYP(I).EQ.TYPEQM(J)) THEN
              VLJRADQM(I) = VRADQM(J)
              VLJEPSQM(I) = VEPSQM(J)
            END IF
          END DO
        ELSE
          DO J=1,NQMCLASS
            IF (QMCLASS(I).EQ.CLASS2(J)) THEN
              VLJRADQM(I) = VRADQM(J)
              VLJEPSQM(I) = VEPSQM(J)
            END IF
          END DO
        END IF
      END DO
C
      DO I=1,NATOM
        IF (VLJRADQM(I).NE.0.0) THEN
          NATOMVDW = NATOMVDW + 1
          ATQMVDW(NATOMVDW) = I
        END IF
      END DO
C
C     *** Preparing Type VDW properties ***
C
      DO I=1,NATOM
C
        IF (RADTYPE.EQ.'SIGMA') THEN
          VLJRADQM(I) = FACT*VLJRADQM(I)
        END IF
C
        IF (RADSIZ.EQ.'DIAMETER') THEN
          VLJRADQM(I) = 0.5*VLJRADQM(I)
        END IF
        VLJEPSQM(I) = ABS(VLJEPSQM(I))
C
      END DO
CCC ADLL LA
C   
      PRMERR = .FALSE.
      IF (LINKAT) THEN
CCC ADLL LA
        DO I=1,NLATOM
          IATOM = LBOND(I,1)
          JATOM = LBOND(I,2)
          II = QMCLASS(IATOM)
          JJ = MMCLASS(JATOM - NATOM)
C
C        *** typing bonding term involvinf QM atoms ***
C
          DO K=1,NBND
            I1 = MMBOND(K,1)
            I2 = MMBOND(K,2)
            IF ((II.EQ.I1.AND.JJ.EQ.I2).OR.(II.EQ.I2.AND.JJ.EQ.I1)) THEN
              KLBOND(I) = KBND(K)
              LBOND0(I) = BND0(K)
              DO J=1,NALTM
                I3 = LABOND(NALTM,1)
                I4 = LABOND(NALTM,2)
                IF ((II.EQ.I3.AND.JJ.EQ.I4).OR.(II.EQ.I4.AND.JJ.EQ.I3))
     $            THEN
                  LATR(I) = LACR(J)
                  LATC(I) = LACAP(J) 
                END IF
              END DO
            END IF
          END DO
          IF ((KLBOND(I).EQ.NOVAL).OR.
     $       (KLBOND(I).EQ.0.0)) THEN
            WRITE (OUT,5025) IATOM,JATOM,II,JJ
 5025       FORMAT('BOND ACCROSS QM/MM',T19,I5,',',I5,
     $             T33,'(CLASS ',I3,',',I3,')',
     $             T57,'IS NOT DEFINED IN THE FF')
            PRMERR = .TRUE.
          END IF
        END DO
C
C       *** Typing Bond Angles ***
C
      DO I=1,NLBANG
        IATOM = LBANGS(I,1)
        JATOM = LBANGS(I,2)
        KATOM = LBANGS(I,3)
        II = QMCLASS(IATOM)
        JJ = MMCLASS(JATOM - NATOM)
        KK = MMCLASS(KATOM - NATOM)
        DO K=1,NANG
          I1 = MMBANG(K,1)
          I2 = MMBANG(K,2)
          I3 = MMBANG(K,3)
          IF (JJ.EQ.I2) THEN
            IF ((II.EQ.I1.AND.KK.EQ.I3).OR.(II.EQ.I3.AND.KK.EQ.I1)) THEN
              KLANG(I) = KBANG(K)
              LANG0(I) = BANG0(K,1)
            END IF
          END IF
        END DO
CCC TO DO BANGTYPE(I) = 'HARMONIC'
C
C       *** Check for undefined parameter ***
C
        IF ((KLANG(I).EQ.NOVAL).OR.(KLANG(I).EQ.0.0)) THEN
          WRITE (OUT,5030) IATOM,JATOM,KATOM,II,JJ,KK
 5030     FORMAT('ANGLE',T9,I5,',',I5,',',I5,
     $           T33,'(CLASS ',I3,',',I3,',',I3,')',
     $           T57,'IS NOT DEFINED IN THE FF')
          PRMERR = .TRUE.
        END IF
      END DO
C
C     *** Typing torsion angles ***
C
        DO I=1,NLTANG
          IATOM = LTANGS(I,1)
          JATOM = LTANGS(I,2)
          KATOM = LTANGS(I,3)
          LATOM = LTANGS(I,4)
          IF (I.LE.NLTANG1) THEN
            II = QMCLASS(IATOM)
            JJ = QMCLASS(JATOM)
            KK = MMCLASS(KATOM - NATOM)
            LL = MMCLASS(LATOM - NATOM)
          ELSE
            II = QMCLASS(IATOM)
            JJ = MMCLASS(JATOM - NATOM)
            KK = MMCLASS(KATOM - NATOM)
            LL = MMCLASS(LATOM - NATOM)
          END IF
          DO K=1,NTANG
            I1 = MMTANG(K,1)
            I2 = MMTANG(K,2)
            I3 = MMTANG(K,3)
            I4 = MMTANG(K,4)
            IF (((II == I1).AND.(JJ == I2).AND.
     $           (KK == I3).AND.(LL == I4)).OR.
     $          ((II == I4).AND.(JJ == I3).AND.
     $           (KK == I2).AND.(LL == I1))) THEN
              LTORS1(I,1) = TANG1(K,1)
              LTORS1(I,2) = TANG1(K,2)
              LTORS2(I,1) = TANG2(K,1)
              LTORS2(I,2) = TANG2(K,2)
              LTORS3(I,1) = TANG3(K,1)
              LTORS3(I,2) = TANG3(K,2)
            END IF
          END DO
C
C         *** Check for undefined parameter ***
C
          IF ((LTORS1(I,1).EQ.NOVAL).AND.(LTORS2(I,1).EQ.NOVAL).AND.
     $        (LTORS3(I,1).EQ.NOVAL)) THEN
            WRITE (OUT,5040) IATOM,JATOM,KATOM,LATOM,II,JJ,KK,LL
 5040       FORMAT('TORSION',I6,',',I5,',',I5,',',I5,
     $             ' (CLASS ',I3,',',I3,',',I3,',',I3,
     $             ') IS NOT DEFINED IN THE FF')
            PRMERR = .TRUE.
          END IF
C
        END DO
      END IF
C
C     *** Exit if undefined parameter were found ***
C
      IF (PRMERR) CALL ERRMSG('TYPINGQM','UNDEFIENED MM PARAMETER',1)
C
CCC ADLL LA
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE TYPINGQM ***
C
      END
