      SUBROUTINE CONNECQMMM
C
C     Purpose: Calculate connectivity matrix and local
C
C     History: - 
C
C     ******************************************************************
C
C     List of local variables:
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
      INCLUDE 'qmmm.h'
      INCLUDE 'strings.h'
C
      INTEGER I,I1,I2,I3,I4,IATOM,ILA,J,JATOM,JLINK,K,K1,KATOM,L,L1
      CHARACTER*10 LTU,SYMBOL
      LOGICAL FOUND,SKIPTORS
C
      INTEGER QMATYP(MAXLNKAT)
C
C     ------------------------------------------------------------------
C
C     *** Quick return if no link atoms ***
C
      IF (.NOT.LINKAT) RETURN
C
      DO ILA=1,NLATOM
        IATOM = LATQM(ILA,1)
        FOUND = .FALSE.
        DO I=1,NTYPQM
          SYMBOL = TRIM(LABTYPQM(I))
          IF (SYMBOL.EQ.LTU(ATOMLAB(ATOMMAP(IATOM,1)))) THEN
            FOUND = .TRUE.
            QMATYP(ILA) = TYPEQM(I)
          ELSE IF (SYMBOL.EQ.ADJUSTL(LTU(ELSYM(ATOMNO(IATOM))))) THEN
            FOUND = .TRUE.
            QMATYP(ILA) = TYPEQM(I)
          END IF
        END DO
      END DO
C
      NTYPLA = 1
      TYPLA(1,1) = QMATYP(1) 
      TYPLA(1,2) = TYPEMM(LATQM(1,2))
      DO I=2,NLATOM
        I1 = QMATYP(I)
        I2 = TYPEMM(LATQM(I,2))
        K = 1
        DO J=1,I-1
          IF (((I1.EQ.QMATYP(J))).AND.
     $         (I2.EQ.TYPEMM(LATQM(J,2)))) THEN
            K = 0
          END IF
        END DO
        IF (K.NE.0) THEN
          NTYPLA = NTYPLA + 1
          TYPLA(NTYPLA,1) = I1
          TYPLA(NTYPLA,2) = I2
        END IF
      END DO
C
C     *** Connect QM and MM atoms at QM/MM frontier by angles ***
C
      NLBANG = 0
C
      DO ILA=1,NLATOM
        IATOM = LBOND(ILA,1)
        JATOM = LBOND(ILA,2)
C
        IF (LINKMM(JATOM,0).EQ.1) CYCLE
        DO JLINK=1,LINKMM(JATOM,0)
          KATOM = LINKMM(JATOM,JLINK)
          IF (KATOM.NE.IATOM) THEN
            NLBANG = NLBANG + 1
            LBANGS(NLBANG,1) = IATOM 
            LBANGS(NLBANG,2) = JATOM
            LBANGS(NLBANG,3) = KATOM 
          END IF
        END DO
      END DO
C
C     *** Connect QM and MM atoms at QM/MM frontier by torsions ***
C
      NLTANG = 0
      NLTANG1 = 0
C
C       **** Connect all A(QM)--X(QM)--Y(MM)--B(MM) torsions ***
C
      DO ILA=1,NLATOM
        I2 = LBOND(ILA,1)
        I3 = LBOND(ILA,2)
        DO J=1,LINKLA(ILA,0)
          I1 = LINKLA(ILA,J)
          DO K=1,LINKMM(I3,0)
            I4 = LINKMM(I3,K)
            IF ((I4.NE.I2).AND.(I4.NE.I1)) THEN
              IF (.NOT.SKIPTORS(I1,I2,I3,I4)) THEN
                NLTANG = NLTANG + 1
                NLTANG1 = NLTANG1 + 1
                LTANGS(NLTANG,1) = I1
                LTANGS(NLTANG,2) = I2
                LTANGS(NLTANG,3) = I3
                LTANGS(NLTANG,4) = I4
              END IF
            END IF
          END DO
        END DO
      END DO
C
C       **** Connect all X(QM)--Y(MM)--A(MM)--B(MM) torsions ***
C
      DO I=1,NLATOM
        I2 = LBOND(I,1)
        I3 = LBOND(I,2)
        DO K=1,LINKMM(I3,0)
          K1 = LINKMM(I3,K)
          IF (K1.EQ.I2) CYCLE
          DO L=1,LINKMM(K1,0) 
            L1 = LINKMM(K1,L)
            IF (L1.NE.I3) THEN
              IF (.NOT.SKIPTORS(I2,I3,K1,L1)) THEN
                NLTANG = NLTANG + 1
                LTANGS(NLTANG,1) = I2
                LTANGS(NLTANG,2) = I3
                LTANGS(NLTANG,3) = K1
                LTANGS(NLTANG,4) = L1
              END IF
            END IF
          END DO
        END DO  
      END DO
C
      RETURN
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE CONNECQMMM *** 
C
      END

