      SUBROUTINE PRJLA(GRADIENT,DXYZ,OPTION)
C
C     Purpose : Project force on link atom on QM and MM atoms.
C
C     Litterature: Eichler et al. J. Comput. Chemm. 1996, 18, 463.
C
C     History: - Creation (23.07.17, ADLL)
C
C     *****************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'dynamics.h'
      INCLUDE 'flags.h'
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
      INCLUDE 'physic.h'
      INCLUDE 'qmmm.h'
C
      INTEGER DXYZ
      REAL GRADIENT(3,DXYZ)
      CHARACTER*(*) OPTION
C
      INTEGER IATOM,I,ILA,JATOM,LATOM
      REAL NORM,RATIO,SP,U(3)
C
C     -----------------------------------------------------------------
C
C     *** Quick return in not QM/MM job or no LA involved ***
C
      IF ((.NOT.QMMM).OR.(.NOT.LINKAT)) RETURN
C
C     *** Assign default mass, atom number and label to link atoms ***
C
      IF ((OPTION.EQ.'MD').OR.(OPTION.EQ.'OPT')) THEN
C
        DO ILA=1,NLATOM
          IATOM = LATQM(ILA,1)
          JATOM = LATQM(ILA,2) 
          LATOM = LATQM(ILA,3)
          RATIO = LATR(ILA)
C
          U(:) = COORD(1:3,JATOM,CCSET) - COORD(1:3,IATOM,CCSET)
          NORM = SQRT(U(1)**2 + U(2)**2 + U(3)**2)
          U(:) = U(:)/NORM
          SP = 0.0
          DO I=1,3
            SP = SP + U(I)*GRADIENT(I,LATOM) 
          END DO
C
C     *** Projet on QM atom ***
C
            GRADIENT(1:3,IATOM) = GRADIENT(1:3,IATOM) + 
     $                      (1.0 - RATIO)*GRADIENT(1:3,LATOM)
C            GRADIENT(1:3,IATOM) = GRADIENT(1:3,IATOM) + RATIO*SP*U(1:3) 
C     $                      + (1.0 - RATIO)*GRADIENT(1:3,LATOM)
C
C     *** Project on MM atom ***
C
C            GRADIENT(1:3,JATOM) = GRADIENT(1:3,JATOM) - RATIO*SP*U(1:3) 
C     $                      + RATIO*GRADIENT(1:3,LATOM)
C
C     *** Cancel link atom gradients ***
C
            GRADIENT(1:3,LATOM) = RATIO*GRADIENT(1:3,LATOM) 
C
        END DO
C
      END IF
C
C     -----------------------------------------------------------------
C
C     *** End of SUBROUTINE SETLAPOS ***
C     
      END 
