      SUBROUTINE PRTQMMMBRD 
C
C     Purpose : print summary of MM terms added at the border between 
C               QM and MM region. 
C
C     *****************************************************************
C
      IMPLICIT NONE 
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'fileio.h'
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
      INCLUDE 'qmmm.h'
      INCLUDE 'strings.h'
C
      INTEGER IATOM,ILA,IMM,ITYP

      CHARACTER*5 NUM1,NUM2,NUM3,NUM4,NUM5,NUM6,NUM7,NUM8
      CHARACTER*10 LTU,SYMBOL
      CHARACTER*120 PRTSTR,PRTSTR1,PRTSTR2,STRCOMP
C
      INTEGER QMATYP(MAXATOM)
C
C     -----------------------------------------------------------------
C
C     *** Determine the MM class for the QM atoms ***
C
      DO IATOM=1,NATOM
        DO ITYP=1,NTYPQM
          SYMBOL = TRIM(LABTYPQM(ITYP))
          IF (SYMBOL.EQ.LTU(ATOMLAB(ATOMMAP(IATOM,1)))) THEN
            QMCLASS(IATOM) = CLASSOFTYP2(TYPEQM(ITYP))
            QMATYP(IATOM) = TYPEQM(ITYP)
          ELSE IF (SYMBOL.EQ.ADJUSTL(LTU(ELSYM(ATOMNO(IATOM))))) THEN
            QMCLASS(IATOM) = CLASSOFTYP2(TYPEQM(ITYP))
            QMATYP(IATOM) = TYPEQM(ITYP)
          END IF
        END DO
      END DO
C
C     *** Write header ***
C
      CALL MESSAGE(1,'SUMMARY OF MM TERMS ACCROSS QM/MM FRONTIER',1,1)
C
      DO ILA=1,NLATOM
        WRITE (PRTSTR,3000) ILA
        CALL MESSAGE(0,STRCOMP(PRTSTR),0,0)
C
        WRITE(NUM1,'(I4)') LATQM(ILA,1)
        WRITE(NUM2,'(I4)') QMATYP(LATQM(ILA,1))
        PRTSTR1 = 'QM ATOM '//TRIM(ADJUSTL(NUM1))//' TYPE('
     $//TRIM(ADJUSTL(NUM2))
        PRTSTR1 = TRIM(PRTSTR1)//')'
        WRITE(NUM1,'(I4)') LATQM(ILA,2)
        WRITE(NUM2,'(I4)') TYPEMM(LATQM(ILA,2))
        PRTSTR2 = 'MM ATOM '//TRIM(ADJUSTL(NUM1))//' TYPE('
     $//TRIM(ADJUSTL(NUM2))
        PRTSTR2 = TRIM(PRTSTR2)//')'
        WRITE (OUT,3100) TRIM(ADJUSTL(PRTSTR1)),TRIM(ADJUSTL(PRTSTR2))
C
C       *** Print MM bonding terms ***
C
        WRITE(NUM1,'(I4)') LATQM(ILA,1) 
        WRITE(NUM2,'(I4)') LATQM(ILA,2)
        WRITE(NUM3,'(I4)') QMCLASS(LATQM(ILA,1))
        WRITE(NUM4,'(I4)') MMCLASS(LATQM(ILA,2) - NATOM)
        WRITE(OUT,3200) TRIM(ADJUSTL(NUM1)),TRIM(ADJUSTL(NUM2)),
     $                  TRIM(ADJUSTL(NUM3)),TRIM(ADJUSTL(NUM4))
C
C       *** Print MM angle terms ***
C
        DO IMM=1,NLBANG
          IF (LBANGS(IMM,1).NE.LATQM(ILA,1)) CYCLE
          WRITE(NUM1,'(I4)') LBANGS(IMM,1) 
          WRITE(NUM2,'(I4)') LBANGS(IMM,2)
          WRITE(NUM3,'(I4)') LBANGS(IMM,3)
          WRITE(NUM4,'(I4)') QMCLASS(LBANGS(IMM,1)) 
          WRITE(NUM5,'(I4)') MMCLASS(LBANGS(IMM,2) - NATOM)
          WRITE(NUM6,'(I4)') MMCLASS(LBANGS(IMM,3) - NATOM)

          WRITE(OUT,3300) TRIM(ADJUSTL(NUM1)),TRIM(ADJUSTL(NUM2)),
     $                    TRIM(ADJUSTL(NUM3)),TRIM(ADJUSTL(NUM4)),
     $                    TRIM(ADJUSTL(NUM5)),TRIM(ADJUSTL(NUM6))
        END DO
C
C     *** Print MM torsion terms ***
C
        DO IMM=1,NLTANG
          IF ((LTANGS(IMM,1).NE.LATQM(ILA,1)).AND.
     $        (LTANGS(IMM,2).NE.LATQM(ILA,1))) CYCLE
          WRITE(NUM1,'(I4)') LTANGS(IMM,1)
          WRITE(NUM2,'(I4)') LTANGS(IMM,2)
          WRITE(NUM3,'(I4)') LTANGS(IMM,3)
          WRITE(NUM4,'(I4)') LTANGS(IMM,4)
          IF (LTANGS(IMM,2).EQ.LATQM(ILA,1)) THEN
            WRITE(NUM5,'(I4)') QMCLASS(LTANGS(IMM,1))
            WRITE(NUM6,'(I4)') QMCLASS(LTANGS(IMM,2))
          ELSE IF (LTANGS(IMM,1).EQ.LATQM(ILA,1)) THEN
            WRITE(NUM5,'(I4)') QMCLASS(LTANGS(IMM,1))
            WRITE(NUM6,'(I4)') MMCLASS(LTANGS(IMM,2) - NATOM)
          END IF
          WRITE(NUM7,'(I4)') MMCLASS(LTANGS(IMM,3) - NATOM)
          WRITE(NUM8,'(I4)') MMCLASS(LTANGS(IMM,4) - NATOM)

          WRITE(OUT,3400) TRIM(ADJUSTL(NUM1)),TRIM(ADJUSTL(NUM2)),
     $                    TRIM(ADJUSTL(NUM3)),TRIM(ADJUSTL(NUM4)),
     $                    TRIM(ADJUSTL(NUM5)),TRIM(ADJUSTL(NUM6)),
     $                    TRIM(ADJUSTL(NUM7)),TRIM(ADJUSTL(NUM8))
        END DO
      END DO
C
3000  FORMAT('LINK ATOM ',I4)
3100  FORMAT(T3,A,' - ',A)
3200  FORMAT('  BOND ',A,' - ',A,' CLASS(',A,',',A,')')
3300  FORMAT('  ANGLE ',A,' - ',A,' - ',A,' CLASS(',A,',',A,',',A,')')
3400  FORMAT('  TORSION ',A,' - ',A,' - ',A,' - ',A,' CLASS(',A,',',A,
     $       ',',A,',',A,')')
C
C     -----------------------------------------------------------------
C
C     *** End of SUBROUTINE PRTQMMMBRD ***
C
      END
