      SUBROUTINE SCLCHGMM(OPTION)
C
C     Purpose: scale down charges of MM atom to avoid overpolarization
C              of the electron density
C 
C     History: - Creation (24.07.18, ADLL)
C
C     *****************************************************************
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'mm.h'
      INCLUDE 'molecule.h'
      INCLUDE 'mmscale.h'
      INCLUDE 'qmmm.h'
C
      CHARACTER*(*) OPTION
C
      INTEGER IATOM,ICH,ILA,ILINK,JATOM,KATOM
      REAL RATIO
      REAL SAVECHG(MAXATMM)
C
      SAVE SAVECHG
C
C     -----------------------------------------------------------------
C
C     *** Quick return if no link atoms are present ***
C 
      IF (.NOT.LINKAT) RETURN
C
C     *** Scale MM charges ***
C
      IF (OPTION.EQ.'SCALE') THEN
        ICH = 0
        DO ILA=1,NLATOM
C
          IATOM = LATQM(ILA,1)
          JATOM = LATQM(ILA,2) 
C
          IF (LINKMM(JATOM,0).EQ.1) CYCLE
          RATIO = 1.0/(REAL(LINKMM(JATOM,0))-1.0)
          DO ILINK=1,LINKMM(JATOM,0)
            KATOM = LINKMM(JATOM,ILINK)
            IF (KATOM.EQ.IATOM) CYCLE
            ICH = ICH + 1
            SAVECHG(ICH) = CHGMM(KATOM-NATOM)
            CHGMM(KATOM-NATOM) = CHGMM(KATOM-NATOM) + 
     $      RATIO*CHGMM(JATOM-NATOM)*(1.0 - L3SCALE)
          END DO
C
          ICH = ICH + 1
          SAVECHG(ICH) = CHGMM(JATOM-NATOM)
          CHGMM(JATOM-NATOM) = CHGMM(JATOM-NATOM)*(1.0 - L2SCALE)
C        WRITE(7,'(T2,A,5(F8.5,2X))') "CHA",CHGMM(1:5)
      END DO
C
C     *** Restore original charges ***
C
      ELSE IF (OPTION.EQ.'RESTORE') THEN
        ICH = 0
        DO ILA=1,NLATOM
C
          IATOM = LATQM(ILA,1)
          JATOM = LATQM(ILA,2)
C
          IF (LINKMM(JATOM,0).EQ.1) CYCLE
          DO ILINK=1,LINKMM(JATOM,0)
            KATOM = LINKMM(JATOM,ILINK)
            IF (KATOM.EQ.IATOM) CYCLE
            ICH = ICH + 1
            CHGMM(KATOM-NATOM) = SAVECHG(ICH)
          END DO
          ICH = ICH + 1
          CHGMM(JATOM-NATOM) = SAVECHG(ICH)
        END DO
C      WRITE(7,'(T2,A,5(F8.5,2X))') "CHA",CHGMM(1:5)
      END IF
C
C     -----------------------------------------------------------------
C
C     *** End of SUBROUTINE SCCHGMM ***
C
      END
