      SUBROUTINE RTGRDOUT(DE1)
C
C     Purpose: Print Cartesian gradients during RT-DFT simulations.
C
C     History: - Creation (22.09.01, ADLL)
C
C     ******************************************************************
C
C     List of local variables:
C
C     DE1: Gradient vector.
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'fileio.h'
      INCLUDE 'flags.h'
      INCLUDE 'molecule.h'
      INCLUDE 'physic.h'
      INCLUDE 'rtdft.h'
C
      REAL DE1(*)
C
      INTEGER IATOM,ICOOR
      REAL TIME
C
        TIME = 1.0E3*RTT/FSEC  
      DO IATOM=1,NATOM_ALL
        WRITE (RTP,5050) TIME,IATOM,ATOMLAB(ATOMMAP(IATOM,1)),
     $                   (DE1(3*(IATOM-1)+ICOOR),ICOOR=1,3)
      END DO
5050    FORMAT (T2,F12.3,' GRADIENT ATOM ',I4,1X,A7,3(F10.6,4X))
      END 
