      SUBROUTINE RTPKEY(KEYWORD,KEYSTR,OPTION)
C
C     Purpose: Check and modify Real time DFT keyword. 
C
C     History: - Creation (14.12.18, ADLL)
C
C     ******************************************************************
C
C     List of local variables:
C
C     KEYSTR : Keyword string.
C     KEYWORD: Keyword name.
C     OPTION : a) NEW = Write new TRAJECTORY keyword string.
C              b) MODIFY = Modify TRAJECTORY keyword string.
C
C     ******************************************************************
C
      IMPLICIT NONE
C
      CHARACTER*(*) KEYSTR,KEYWORD,OPTION
C
      CHARACTER*500 STRCOM,STRCOMP
      INTEGER ITOKEN,KEYLEN,NTOKEN,STREXT,TOKLEN
C
      LOGICAL TAKE(80)
      CHARACTER*80 TOKEN(500)
C
C     ------------------------------------------------------------------
C
C     *** Quick return, if not TRAJECTORY keyword ***
C
      IF (KEYWORD.NE.'RTDFT') RETURN
C
C     *** Write new TRAJECTORY keyword string ***
C
      IF (OPTION.EQ.'NEW') THEN
C
        KEYSTR = 'RTDFT RESTART'
C
C     *** Modify TRAJECTORY keyword string ***
C
      ELSE IF (OPTION.EQ.'MODIFY') THEN
C
C     *** Tokenize keyword string ***
C
        KEYSTR = STRCOM(KEYSTR(:STREXT(KEYSTR)))
        CALL STRTOK(KEYSTR,NTOKEN,TOKEN)
C
C     *** Check trajectory option assignment ***
C
        TAKE(:) = .FALSE.
C
        DO ITOKEN=1,NTOKEN
          IF (INDEX(TOKEN(ITOKEN),'RESTA').EQ.0) TAKE(ITOKEN) = .TRUE.
        END DO
C
C     *** Build restart real time DFT keyword ***
C
        KEYSTR = 'RTDFT RESTART'
C
        DO ITOKEN=2,NTOKEN
          IF (TAKE(ITOKEN)) THEN
            KEYLEN = STREXT(KEYSTR)
            TOKLEN = STREXT(TOKEN(ITOKEN))
            KEYSTR = KEYSTR(:KEYLEN)//' '//TOKEN(ITOKEN)(:TOKLEN)
            KEYSTR = STRCOMP(KEYSTR)
          END IF
        END DO
C
      END IF
C
C     ------------------------------------------------------------------
C
C     *** End of SUBROUTINE TRJKEY ***
C
      END
