# $Id: au-iso.vmd,v 1.2 2004/05/21 15:50:29 akohlmey Exp $
# Display settings
display projection   Orthographic
display nearclip set 0.000000
display farclip  set 10.000000
display depthcue   off
# store the molecule id for later use
set updmol [mol new {RHO_3.cube} type cube waitfor all volsets 0]
for {set i 10} {$i <=1000} {incr i 1} {
mol addfile RHO_$i.cube type cube waitfor all volsets 0 }


mol delrep 0 top
mol representation CPK 0.20000 0.100000 20.000000 16.000000
mol color Name
mol selection {all}
mol material Opaque
mol addrep top

mol representation CPK 0.20000 0.100000 20.000000 16.000000
mol selection {element He}
mol color ColorID  3
mol addrep top

mol representation Isosurface 0.8 0.0 0.0 0.0
mol color ColorID 21
mol addrep top
set updrep [mol repname top 2]
mol rename top {Golden Shot}



rotate z by -90
rotate x by -90
rotate x by 2
rotate y by 3
rotate x by 2

#
proc update_iso {args} { 
    global updmol
    global updrep

    # get representation id and return if invalid
    set repid [mol repindex $updmol $updrep]
    if {$repid < 0} { return }

    # update representation but replace the data set 
    # id with the current frame number.
    set frame [molinfo $updmol get frame]
    lassign [molinfo $updmol get "{rep $repid}"] rep
    mol representation [lreplace $rep 2 2 $frame]
    mol modrep $repid $updmol
    
}


trace variable vmd_frame($updmol) w update_iso
animate goto 0


